// ACe[h

// ACe[hNX
function ItemMode(fieldView, textView, pcModel, partyModel, selectionMode) {
	this.fieldView = fieldView;
	this.textView = textView;
	this.pcModel = pcModel;
	this.partyModel = partyModel;
	this.selectionMode = selectionMode;

}

// ACe[hJni퓬ȊOj
ItemMode.prototype.start = function(location, pcNum) {
	KeyManager_addListener(this);
	this.location = location;
	this.mode = 'itemSel';
	this.party = this.partyModel[Party];
	this.selectionMode.party = this.party;
	var i, count = 0;
	for (i = 0; i < this.party.pc.length; i++) {
		if (this.party.pc[i] == 0) { break; }
		if (this.party.pc[i] == pcNum) {
			this.pcNum = i;
		}
		count++;
	}
	this.ppcLen = count;
	this.pc = this.pcModel[this.party.pc[this.pcNum]];
	this.stop = 0, this.oops = 0;
	this.update(0);
}

// Jn
ItemMode.prototype.equipmentStart = function(location, pcNum) {
	KeyManager_addListener(this);
	this.stop = 0, this.oops = 0;
	this.location = location;
	this.mode = 'equipment';
	this.party = this.partyModel[Party];
	this.selectionMode.party = this.party;
	this.pcNum = pcNum;
	this.pc = this.pcModel[this.pcNum];
	this.selNum = 0;
	this.equipmentCheck();
	this.update(0);
}

// ̃`FbN
ItemMode.prototype.equipmentCheck = function() {
	var i, item, min = this.selNum;
	this.selNum = 7;
	for (i = 0; i < this.pc.item.length; i++) {
		item = itemData(this.pc.item[i]);
		if (item[0] > min && item[0] < this.selNum && item[3] > 0) {
			this.selNum = item[0];
		}
	}
}

// I
ItemMode.prototype.end = function() {
	KeyManager_removeListener(this);
	if (this.location == 'town') {
		if (this.mode == 'equipment' || this.mode == 'equipmentSP') {
			gameMode.townMode.update(1);
		} else {
			gameMode.townMode.pcNum = this.pcNum;
			gameMode.townMode.update(0);
		}
	} else if (this.location == 'dungeon') {
		var spell = 0, num;
		if (this.pc.mSpell[0][0] + this.pc.mSpell[0][1] + this.pc.mSpell[0][2] + this.pc.pSpell[0][0] + this.pc.pSpell[0][1] + this.pc.pSpell[0][2] > 0 && !this.pc.cantMove && this.pc.state != 1 && this.pc.state != 11) {
			spell = 1;
		}
		if (this.mode == 'equipment' || this.mode == 'equipmentSP') {
			if (spell) { num = 2; }
			else { num = 1; }
			gameMode.dungeonMode.camp(num);
		} else {
			if (spell) { num = 1; }
			else { num = 0; }
			gameMode.dungeonMode.pcNum = this.pcNum;
			gameMode.dungeonMode.camp(num);
		}
	}
}

// e̎􂢂`FbN
ItemMode.prototype.curseCheck = function(pcNum) {
	var i, item, curse, pc = this.pcModel[pcNum];
	this.curse = new Array(0,0,0,0,0,0);
	for (i = 0; i < pc.item.length; i++) {
		if (pc.item[i] == 0) { break; }
		if (pc.itemS[i]) {
			item = itemData(pc.item[i]);
			curse = NtoP(item[4]);
			if (curse[pc.alignment]) {
				this.curse[item[0]-1] = 1;
			}
		}
	}
}

// 􂢃bZ[W
ItemMode.prototype.curseView = function() {
	this.stop = 1;
	this.textView.alert(24, 12, 1, 'Ă遖');
	this.fieldView.update();
}

// XyVp[
ItemMode.prototype.spPower = function() {
	var num = this.pc.item[this.selNum];
	var item = itemData(num), i, data;
	if (item[19] >= 2000) { item[19] -= 2000; }
	else if (item[19] >= 1000) { item[19] -= 1000; }
	if (item[19] == 5) {
		for (i = 0; i < this.party.pc.length; i++) {
			if (this.party.pc[i] == 0) { break; }
			this.pcModel[this.party.pc[i]].hpCtrl(9999);
		}
	} else if (item[19] >= 500 && item[19] < 600) {
		item[19] -= 500;
		this.pc.pcClass = item[19];
		var i, item2;
		for (i = 0; i < this.pc.item.length; i++) {
			if (this.pc.item[i] == 0) { break; }
			if (this.pc.itemS[i]) {
				item2 = itemData(this.pc.item[i]);
				data = NtoP(item2[3]);
				if(!data[this.pc.pcClass]) {
					this.pc.itemS[i] = 0;
				}
			}
		}
		for (i = 0; i < 7; i++) {
			this.pc.mpMMax[i] = 0, this.pc.mpPMax[i] = 0;
			this.pc.mpUp();
			if (this.pc.mpM[i] > this.pc.mpMMax[i]) {
				this.pc.mpM[i] = this.pc.mpMMax[i];
			}
			if (this.pc.mpP[i] > this.pc.mpPMax[i]) {
				this.pc.mpP[i] = this.pc.mpPMax[i];
			}
		}
	} else if (item[19] >= 600 && item[19] < 800) {
		var plus = -1, abi;
		if (item[19] >= 700) { item[19] -= 700; }
		else {
			item[19] -= 600;
			plus = 1;
		}
		abi = Math.floor(item[19] / 10);
		item[19] = item[19] % 10;
		if (abi == 6) {
			this.pc.hpMax += item[19] * plus;
		} else if (abi < 6) {
			this.pc.abi[abi] += item[19] * plus;
			if (this.pc.abi[abi] > ABILITY[this.pc.race][abi]+10) {
				this.pc.abi[abi] = ABILITY[this.pc.race][abi]+10;
			}
		}
	}
	if (dice(1,100) <= item[20]) {
		this.pc.item[this.selNum] = item[21] + 10000;
		item = itemData(this.pc.item[this.selNum]);
		data = NtoP(item[3]);
		if(!data[this.pc.pcClass]) {
			this.pc.itemS[this.selNum] = 0;
		}
	}
	this.pc.check(this.party.protection);
}

// pcACẽXg
ItemMode.prototype.pcItemList = function(mode, alignY, num) {
	this.textView.textFrame(30, 12);
	var i, j = 0, y = 9, item, text;
	this.sortO = new Array(0);
	for (i = 0; i < this.pc.item.length; i++) {
		if (this.pc.item[i] == 0) { break; }
		item = itemData(this.pc.item[i]);
		text = itemStr(this.pc.item[i], this.pc.itemS[i], this.pc.alignment, this.pc.pcClass);
		this.textView.write(4, y, text);
		y--;
		this.sortO[j] = i+1;
		j++;
	}
	this.textView.textSet('center', alignY+11, alignY);
	if (mode) {
		this.selectionMode.startNon(this,this.sortO,alignY+9,9,num);
	}
}

// pcACẽXg2
ItemMode.prototype.pcItemList2 = function(numList, itemAry, itemAryS, alignment, pcClass, alignY) {
	this.textView.textFrame(29, 12);
	var i, j = 0, y = 9, item, text;
	if (numList) {
		for (i = 0; i < 8; i++) {
			this.textView.write(2, y, hzNum(i+1, 0) + 'F');
			y--;
		}
		y = 9;
	}
	this.sortC = new Array(0);
	for (i = 0; i < itemAry.length; i++) {
		if (itemAry[i] == 0) { break; }
		item = itemData(itemAry[i]);
		text = itemStr(itemAry[i], itemAryS[i], alignment, pcClass);
		this.textView.write(4, y, text), y--;
		this.sortC[j] = i+1;
		j++;
	}
	this.textView.textSet('center', alignY+11, alignY);
}

// ACe̎󂯓n\
ItemMode.prototype.itemHand = function(num) {
	var i, y, item, text;
	this.textView.textFrame(29, 12);
	this.sortO = new Array(0);
	y = 9;
	for (i = 0; i < this.pc.item.length; i++) {
		if (this.pc.item[i] == 0) { break; }
		item = itemData(this.pc.item[i]);
		text = itemStr(this.pc.item[i], this.pc.itemS[i], this.pc.alignment, this.pc.pcClass);
		this.textView.write(4, y, text), y--;
		this.sortO[i] = 1;
	}
	this.textView.textSet('center', 29, 18);
	this.textView.textFrame(29, 13);
	text = '' + this.pc2.name;
	for (i = text.length; i < 7; i++) { text += '@'; }
	text += '';
	this.textView.write(3, 11, text);
	text = abbreviation('race', this.pc2.race);
	text += '|' + abbreviation('alignment', this.pc2.alignment);
	text += '|' + abbreviation('pcClass', this.pc2.pcClass);
	this.textView.write(13, 11, text);
	this.sortC = new Array(0);
	y = 9;
	for (i = 0; i < this.pc2.item.length; i++) {
		if (this.pc2.item[i] == 0) { break; }
		item = itemData(this.pc2.item[i]);
		text = itemStr(this.pc2.item[i], this.pc2.itemS[i], this.pc2.alignment, this.pc2.pcClass);
		this.textView.write(4, y, text), y--;
		this.sortC[i] = 1;
	}
	this.textView.textSet('center', 18, 6);
	if (!num){
		if (this.selNum2 < 10) {
			if (this.sortO.length == 0) { num = 1; }
			else if (this.selNum2 >= this.sortO.length) {
				this.selNum2--;
			}
		} else {
			if (this.sortC.length == 0) { num = 1; }
			else if (this.selNum2 >= this.sortC.length+10) {
				this.selNum2--;
			}
		}
	}
	if (num) {
		if (this.selNum2 < 10) {
			if (this.sortO.length > 0) {
				this.selNum2 = this.sortO.length-1;
			} else if (this.sortC.length > 0) {
				this.selNum2 = this.sortC.length + 9;
			} else { this.selNum2 = 0; }
		} else if (this.selNum2 >= 10) {
			if (this.sortC.length > 0) {
				this.selNum2 = this.sortC.length + 9;
			} else if (this.sortO.length > 0) {
				this.selNum2 = this.sortO.length-1;
			} else { this.selNum2 = 10; }
		}
	}
	if (this.selNum2 < 10) { y = 27 - this.selNum2; }
	else { y = 25 - this.selNum2; }
	if ((this.selNum2 < 10 && this.sortO.length > 0) || (this.selNum2 >= 10 && this.sortC.length > 0)) {
		this.textView.textNonFrame(1, 1);
		this.textView.write(0, 0, '');
		this.textView.textSet(9, y, y);
	}
}

// ړɎgpłpcACẽXg
ItemMode.prototype.pcUseItemList = function(mode, alignY, num) {
	this.textView.textFrame(26, 12);
	var i, j = 0, y = 9, item, text;
	this.sortO = new Array(0);
	for (i = 0; i < this.pc.item.length; i++) {
		if (this.pc.item[i] == 0) { break; }
		item = itemData(this.pc.item[i]);
		if ((item[18] > 0 && item[18] < 1000) || (item[18] > 2000 && item[18] < 3000)) {
			text = itemStr(this.pc.item[i], this.pc.itemS[i], this.pc.alignment, this.pc.pcClass);
			this.textView.write(4, y, text);
			y--;
			this.sortO[j] = i+1;
			j++;
		}
	}
	if (mode < 2) {
		this.textView.textSet('center', alignY+11, alignY);
	}
	if (mode == 1 && !this.oops) {
		if (num >= this.sortO.length) { num = this.sortO.length-1; }
		this.selectionMode.startNon(this,this.sortO,alignY+9,11,num);
	}
}

// ACe̎gp
ItemMode.prototype.itemUse = function() {
	var i, ef = this.itemEfficacy;
	if (this.mode == 'itemUseExe') {
		if (ef <= 4 || ef == 900 || ef == 920 || ef == 921 || ef == 930 || ef == 940 || ef == 950 || ef == 962) {
			this.mode = 'itemUsePcSel';
		} else if (ef == 802) { this.mode = 'itemUseMapView'; }
		else if (ef == 812) {
			this.mode = 'itemUseMapSearch';
			this.fieldView.viewClear();
		} else if (ef == 861) {
			this.mode = 'itemUseMapWarp';
			this.floor = this.party.floor;
			this.x = 0, this.y = 0;
		} else { this.mode = 'itemUseEnd'; }
	}
	if (this.mode == 'itemUseEnd') {
		var end = 0, ptStatus = 0, itemEnd = 1;
		if (ef == 1) {
			this.pcModel[this.targetPc].hpCtrl(dice(1,8));
			ptStatus = 1;
		} else if (ef == 2) {
			this.pcModel[this.targetPc].hpCtrl(dice(2,8));
			ptStatus = 1;
		} else if (ef == 3) {
			this.pcModel[this.targetPc].hpCtrl(dice(3,8));
			ptStatus = 1;
		} else if (ef == 4) {
			var pc = this.pcModel[this.targetPc];
			if (pc.state == 5 || pc.state == 6) { spellEnd = 3; }
			pc.state = 0, pc.hpCtrl(9999);
			for (i = 0; i < pc.mpM.length; i++) {
				pc.mpM[i] = pc.mpMMax[i];
				pc.mpP[i] = pc.mpPMax[i];
			}
			pc.check(this.party.protection);
			ptStatus = 1;
		} else if (ef == 5) {
			for (i = 0; i < this.party.pc.length; i++) {
				if (this.party.pc[i] == 0) { break; }
				this.pcModel[this.party.pc[i]].hpCtrl(9999);
			}
			ptStatus = 1;
		} else if (ef == 861) {
			var ok = UseWarpSpell(this.floor, this.x, this.y);
			if (ok) {
				if (this.party.floor != this.floor) {
					this.party.floor = this.floor;
					gameMode.dungeonMode.roomCheck = new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
				}
				this.party.x = this.x;
				this.party.y = this.y;
				KeyManager_removeListener(this);
				gameMode.dungeonMode.onKeyPress('move');
				if (MusicOn) { musicStart("DUNGEON"); }
				end = 1;
			} else { itemEnd == 2; }
		} else if (ef == 900) {
			this.selectionMode.recoverHp(this.party.pc[this.pcNum], this.targetPc, 0);
			ptStatus = 1;
		} else if (ef == 901) {
			if (this.party.bright < 40) { this.party.bright = 40; }
		} else if (ef == 920) {
			this.selectionMode.recoverHp(this.party.pc[this.pcNum], this.targetPc, 1);
			ptStatus = 1;
		} else if (ef == 921) {
			this.selectionMode.recoverStatus(this.party.pc[this.pcNum], this.targetPc, 0);
			ptStatus = 1;
		} else if (ef == 922) {
			this.party.discrimination = 1;
		} else if (ef == 930) {
			this.selectionMode.recoverStatus(this.party.pc[this.pcNum], this.targetPc, 1);
			ptStatus = 1;
		} else if (ef == 931) {
			this.party.bright = 100;
		} else if (ef == 940) {
			this.selectionMode.recoverHp(this.party.pc[this.pcNum], this.targetPc, 2);
			ptStatus = 1;
		} else if (ef == 941) {
			this.party.protection = 1;
			this.party.check();
		} else if (ef == 950) {
			this.selectionMode.recoverHp(this.party.pc[this.pcNum], this.targetPc, 3);
			ptStatus = 1;
		} else if (ef == 952) {
			this.party.bright = 0, this.party.protection = 0;
			this.party.discrimination = 0, this.party.floor = 0;
			this.party.check();
			KeyManager_removeListener(this);
			KeyManager_removeListener(gameMode.dungeonMode);
			gameMode.townMode.start();
			save(this.pcModel, this.partyModel);
			end = 1;
		} else if (ef == 960) {
			this.selectionMode.party = this.party;
			this.selectionMode.recoverHp(this.party.pc[this.pcNum], 0, 4);
			ptStatus = 1;
		} else if (ef == 962) {
			itemEnd = this.selectionMode.recoverStatus(this.party.pc[this.pcNum], this.targetPc, 2);
			ptStatus = 1;
		}
		var item = itemData(this.itemNum);
		if (dice(1,100) <= item[20]) {
			this.pc.item[this.pcItemNum] = item[21] + 10000;
			item = itemData(this.pc.item[this.pcItemNum]);
			var data = NtoP(item[3]);
			if(!data[this.pc.pcClass]) {
				this.pc.itemS[this.pcItemNum] = 0;
			}
			this.pc.check(this.party.protection);
		}
		if (end) {
			return true;
		} else {
			this.textView.pcStatus(this.party.pc[this.pcNum]);
			if (ptStatus) { this.textView.partyStatus(); }
			this.textView.alert(28, 18, 1, 'ǂg܂H');
			this.pcUseItemList(0, 14, 0);
			var text = 'ACegI';
			if (itemEnd == 2) { text = 'sI'; }
			else if (itemEnd == 3) { text = 'Ԃ'; }
			else if (itemEnd == 4) { text = 'DɂȂ'; }
			else if (itemEnd == 5) { text = 'ł'; }
			this.textView.alert(22, 14, 1, text);
			this.mode = 'itemUse';
			if (this.sortO.length == 0) {
				this.mode = 'itemSel';
				this.selStock = this.selNum;
			}
			this.stop = 1;
			this.fieldView.update();
			return true;
		}
	}
	return false;
}

// ACe̎gpɊւI\
ItemMode.prototype.itemUseView = function(num) {
	if (this.mode == 'itemUsePcSel') {
		this.textView.partyStatus();
		this.sortC = new Array(0);
		for (i = 0; i < this.party.pc.length; i++) {
			if (this.party.pc[i] == 0) { break; }
			this.sortC[i] = 1;
		}
		this.selectionMode.startNon(this, this.sortC, 6, 4, num);
	} else if (this.mode == 'itemUseMapView') {
		this.selectionMode.mapView(this.party.floor, this.party.x, this.party.y, this.party.direction);
		this.stop = 1;
		return;
	} else if (this.mode == 'itemUseMapSearch') {
		this.textView.alert(33, 18, 1, 'NT܂H');
		this.textView.textFrameNonMargin(35, this.pcModel.length + 1);
		var y = this.pcModel.length - 1, name;
		this.sortC = new Array(0);
		for (i = 1; i < this.pcModel.length; i++) {
			if (this.pcModel[i].name == '') { break; }
			name = gameMode.townMode.pcListNameSet(i);
			this.textView.write(3, y, name);
			this.sortC[i-1] = 1;
			y--;
		}
		this.textView.textSet('center', 29, 29 - this.pcModel.length);
		this.selectionMode.startNon(this, this.sortC, 28, 5, num);
	} else if (this.mode == 'itemUseMapSearchView') {
		var pc = this.pcModel[num+1], text;
		if (pc.party >= 0) {
			var party = this.partyModel[pc.party];
			if (party.floor == 0) {
				text = pc.name + '́DDD\n\n@@@nɂ܂';
				this.textView.message(34, 12, 'center', text, 'left');
			} else if (pc.party == Party) {
				text = pc.name + '́DDD\n\n@@@ɂ܂';
				this.textView.message(34, 12, 'center', text, 'left');
			} else {
				this.selectionMode.mapView(party.floor, party.x, party.y, 'none');
			}
		} else {
			text = pc.name + '́DDD\n\n@@@nɂ܂';
			this.textView.message(34, 12, 'center', text, 'left');
		}
		this.stop = 1;
	} else if (this.mode == 'itemUseMapWarp') {
		this.selectionMode.mapView(this.floor, this.x, this.y, 'map');
		return;
	}
}

// \
ItemMode.prototype.update = function(num) {
	if (this.mode == 'equipment') {
		this.pc.check(this.party.protection);
		this.textView.pcStatus(this.pcNum);
		var text, i, item, tmp;
		if (this.selNum == 1) { text = ''; }
		else if (this.selNum == 2) { text = 'Z'; }
		else if (this.selNum == 3) { text = ''; }
		else if (this.selNum == 4) { text = ''; }
		else if (this.selNum == 5) { text = ''; }
		else if (this.selNum == 6) { text = '̑'; }
		this.textView.alert(28, 18, 1, text + 'Ił');
		this.textView.textFrame(28, 13);
		var j = 0, y = 10;
		this.sortO = new Array(0);
		for (i = 0; i < this.pc.item.length; i++) {
			if (this.pc.item[i] == 0) { break; }
			item = itemData(this.pc.item[i]);
			if (item[0] == this.selNum && item[3] > 0) {
				text = itemStr(this.pc.item[i], this.pc.itemS[i], this.pc.alignment, this.pc.pcClass);
				this.textView.write(4, y, text);
				y--;
				this.sortO[j] = i+1;
				j++;
			}
		}
		this.textView.write(5, y, 'Ȃ');
		this.sortO[j] = 9;
		this.textView.textSet('center', 25, 13);
		this.selectionMode.startNon(this, this.sortO, 23, 10, num);
	} else if (this.mode == 'equipmentSP') {
		var item, data;
		while (this.selNum < this.pc.item.length) {
			if (this.pc.item[this.selNum] == 0) {
				this.selNum = this.pc.item.length;
				break;
			}
			item = itemData(this.pc.item[this.selNum]);
			data = NtoP(item[3]);
			if (data[this.pc.pcClass] && item[19] > 0 && !this.pc.cantMove) {
				this.textView.pcStatus(this.pcNum);
				var text;
				if (this.pc.item[this.selNum] >= 10000) {
					text = 'H' + abbreviation('item', item[2]);
				} else { text = item[1]; }
				this.textView.message(31, 26, 'center', text + 'ɔ߂ꂽ͂܂H\n\n@͂\n@@', 'center');
				var choice = new Array(1,1);
				this.selectionMode.startNon(this, choice, 26, 19, num);
				break;
			}
			this.selNum++;
			num = 1;
		}
		if (this.selNum >= this.pc.item.length) {
			this.end();
			return;
		}
	} else if (this.mode == 'itemSel') {
		this.party.check();
		this.textView.pcStatus(this.party.pc[this.pcNum]);
		var choice = new Array(0);
		this.sortSel = new Array(0);
		var tmp = 0;
		if (this.location == 'dungeon' && this.pc.item[0] > 0) {
			choice[tmp] = 'g';
			this.sortSel[tmp] = 0, tmp++;
		}
		choice[tmp] = 'n', this.sortSel[tmp] = 1, tmp++;
		if (this.pc.item[0] > 0) {
			choice[tmp] = '̂Ă';
			this.sortSel[tmp] = 2, tmp++;
			var state = this.pc.state;
			if (this.pc.pcClass == 4 && !this.pc.cantMove && state != 1 && state != 11) {
				choice[tmp] = 'Ӓ';
				this.sortSel[tmp] = 3, tmp++;
			}
			choice[tmp] = 'בւ';
			this.sortSel[tmp] = 4, tmp++;
		}
		choice[tmp] = '߂', this.sortSel[tmp] = 5;
		this.selectionMode.start(this, choice, 25, 26, num);
	} else if (this.mode == 'itemUse') {
		this.textView.pcStatus(this.party.pc[this.pcNum]);
		this.textView.alert(28, 18, 1, 'ǂg܂H');
		this.pcUseItemList(1, 14, num);
	} else if (this.mode == 'itemUsePcSel' || this.mode == 'itemUseMapView' || this.mode == 'itemUseMapSearch' || this.mode == 'itemUseMapSearchView' || this.mode == 'itemUseMapWarp') {
		this.itemUseView(num);
	} else if (this.mode == 'itemHand') {
		this.textView.alert(32, 9, 1, 'ACen');
		this.itemHand(num);
	} else if (this.mode == 'itemDump') {
		this.textView.alert(28, 18, 1, 'ǂ̂Ă܂H');
		this.pcItemList(1, 14, num);
	} else if (this.mode == 'itemIdentify') {
		this.textView.alert(28, 18, 1, 'ǂӒ肵܂H');
		this.pcItemList(1, 14, num);
	} else if (this.mode == 'itemSort') {
		this.textView.alert(32, 9, 1, 'ACe̕בւ');
		this.pcItemList2(1, this.itemC, this.itemCS, this.pc.alignment, this.pc.pcClass, 18);
		this.pcItemList2(0, this.itemO, this.itemOS, this.pc.alignment, this.pc.pcClass, 7);
		if (this.itemO[0] > 0) {
			if (this.itemO[num] == 0) { num--; }
			this.selectionMode.startNon(this,this.itemO,16,9, num);
		} else { this.selNum2 = num; }
	}
	if (!this.oops) { this.fieldView.update(); }
}

// E
ItemMode.prototype.rightEnter = function(num) {
	if (this.mode == 'itemSel') {
		this.pcNum++;
		if (this.pcNum >= this.ppcLen) { this.pcNum = 0; }
		this.pc = this.pcModel[this.party.pc[this.pcNum]];
		num = 0;
	} else if (this.mode == 'itemUseMapSearch') {
		num += 6;
		if (num >= this.sortC.length) { num = this.sortC.length-1; }
	}
	this.update(num);
}

// 
ItemMode.prototype.leftEnter = function(num) {
	if (this.mode == 'itemSel') {
		this.pcNum--;
		if (this.pcNum < 0) { this.pcNum = this.ppcLen - 1; }
		this.pc = this.pcModel[this.party.pc[this.pcNum]];
		num = 0;
	} else if (this.mode == 'itemUseMapSearch') {
		num -= 6;
		if (num < 0) { num = 0; }
	}
	this.update(num);
}

// 
ItemMode.prototype.enter = function(num) {
	if (this.mode == 'equipment') {
		var i, item, data;
		this.curseCheck(this.pcNum);
		if (this.curse[this.selNum-1]) {
			this.curseView();
			return;
		}
		if (this.sortO[num] == 9) {
			for (i = 0; i < this.sortO.length-1; i++) {
				this.pc.itemS[this.sortO[i]-1] = 0;
			}
			this.equipmentCheck();
			num = 0;
		} else {
			item = itemData(this.pc.item[this.sortO[num]-1]);
			data = NtoP(item[3]);
			if(data[this.pc.pcClass]) {
				for (i = 0; i < this.sortO.length-1; i++) {
					this.pc.itemS[this.sortO[i]-1] = 0;
				}
				this.pc.itemS[this.sortO[num]-1] = 1;
				this.curseCheck(this.pcNum);
				if (this.curse[this.selNum-1]) {
					this.curseView();
					return;
				}
				this.equipmentCheck();
				num = 0;
			}
		}
		if (this.selNum > 6) {
			this.mode = 'equipmentSP';
			num = 1;
			this.selNum = 0;
			this.pc.check(this.party.protection);
		}
	} else if (this.mode == 'equipmentSP') {
		if (num == 0) { this.spPower(); }
		this.selNum++;
		num = 1;
	} else if (this.mode == 'itemSel') {
		this.selNum = num;
		this.textView.pcStatus(this.party.pc[this.pcNum]);
		if (this.sortSel[num] == 0) {
			this.pcUseItemList(2, 14, 0);
			if (this.sortO.length > 0 && !this.pc.cantMove) {
				this.mode = 'itemUse', num = 0;
			}
		} else if (this.sortSel[num] == 1) {
			if (this.party.pc[1] > 0) {
				this.mode = 'itemHand', num = 1;
				this.selNum2 = 0;
				this.pcNum2 = this.pcNum+1;
				if (this.pcNum2 >= this.ppcLen) {
					this.pcNum2 = 0;
				}
				this.pc2 = this.pcModel[this.party.pc[this.pcNum2]];
			}
		} else if (this.sortSel[num] == 2) {
			this.mode = 'itemDump', num = 0;
		} else if (this.sortSel[num] == 3) {
			num = -1;
			var i;
			for (i = 0; i < this.pc.item.length; i++) {
				if (this.pc.item[i] == 0) { break; }
				else if (this.pc.item[i] >= 10000) {
					num = i;
					break;
				}
			}
			if (num >= 0) {
				this.mode = 'itemIdentify';
			} else { num = this.selNum; }
		} else if (this.sortSel[num] == 4) {
			if (this.pc.item[1] > 0) {
				this.mode = 'itemSort', num = 0;
				var i;
				this.itemO = new Array(0);
				this.itemOS = new Array(0);
				this.itemC = new Array(0);
				this.itemCS = new Array(0);
				for (i = 0; i < this.pc.item.length; i++) {
					this.itemO[i] = this.pc.item[i];
					this.itemOS[i] = this.pc.itemS[i];
					this.itemC[i] = 0, this.itemCS[i] = 0;
				}
			}
		} else if (this.sortSel[num] == 5) {
			this.end();
			return;
		}
	} else if (this.mode == 'itemUse') {
		this.selectionMode.pM = this.pcModel;
		this.selectionMode.party = this.partyModel[Party];
		this.mode = 'itemUseExe';
		this.selStock = num;
		this.pcItemNum = this.sortO[num]-1;
		this.itemNum = this.pc.item[this.pcItemNum];
		var item = itemData(this.itemNum);
		if (item[18] >= 2000) { item[18] -= 2000; }
		this.itemEfficacy = item[18];
		if (this.itemUse()) { return; }
		num = 0;
	} else if (this.mode == 'itemUsePcSel') {
		this.mode = 'itemUseEnd';
		this.targetPc = this.party.pc[num];
		if (this.itemUse()) { return; }
	} else if (this.mode == 'itemUseMapSearch') {
		this.mode = 'itemUseMapSearchView';
	} else if (this.mode == 'itemDump') {
		var item = itemData(this.pc.item[num]);
		var curse = NtoP(item[4]), text = '';
		if (this.pc.itemS[num]) {
			if (curse[this.pc.alignment]) {
				text = 'Ă遖';
			} else {
				text = 'Ă遖';
			}
		} else {
			this.pc.deleteItem(num);
			if (this.pc.item[0] == 0) {
				this.mode = 'itemSel';
				num = 0;
			} else if (this.pc.item[num] == 0) { num--; }
			this.textView.pcStatus(this.party.pc[this.pcNum]);
		}
		if (text != '') {
			this.textView.alert(24, 12, 1, text);
			this.stop = 1;
			this.fieldView.update();
			this.selStock = num;
			return;
		}
	} else if (this.mode == 'itemIdentify') {
		if (this.pc.item[num] >= 10000) {
			var viewtext = '', tmp;
			var r = this.pc.abi[1] + this.pc.abi[5];
			r = Math.floor(r / 2);
			var lvBonus = this.pc.level * 4, check = 0;
			if (lvBonus > 72) { lvBonus = 72; }
			r += lvBonus;
			if (r > 90) { r = 90; }
			else if (r < 10) { r = 10; }
			if (View) {
				tmp = r;
				viewtext = 'Ӓ萬F' + hzNum(r, 0) + '';
			}
			if (dice(1,100) <= r) {
				check = 1;
			} else {
				var item = itemData(this.pc.item[num]);
				if (item[4] > 0) {
					var curse = NtoP(item[4]);
					var data = NtoP(item[3]);
					r = this.pc.abi[4] + this.pc.abi[5];
					r = Math.floor(r / 2);
					lvBonus = this.pc.level * 3;
					if (lvBonus > 63) { lvBonus = 63; }
					r += lvBonus;
					if (r > 90) { r = 90; }
					else if (r < 10) { r = 10; }
					r = 100 - r;
					if (View) {
						tmp = 100 - tmp;
						tmp = tmp * r;
						tmp = Math.floor(tmp / 100);
						viewtext += '\nmF';
						viewtext += hzNum(tmp, 0) + '';
					}
					if (dice(1,100) <= r) {
						if (curse[this.pc.alignment] && data[this.pc.pcClass]) {
							check = 2;
						} else { check = 3; }
					}
				}
			}
			var text = '';
			if (check == 0) {
				text = '̎|Ȃ';
			} else if (check == 1) {
				this.pc.item[num] -= 10000;
				text = 'Ӓł܂I';
				var i = num+1, tmp = -1;
				while (true) {
					if (i > 7) { i = 0; }
					else if (this.pc.item[i] == 0) {
						i = 0;
					}
					if (i == num) { break; }
					if (this.pc.item[i] >= 10000) {
						tmp = i;
						break;
					}
					i++;
				}
				if (tmp >= 0) { num = tmp; }
				else {
					num = this.selNum;
					this.mode = 'itemSel';
				}
			} else if (check == 2) {
				this.pc.itemS[num] = 1;
				text = 'Ă遖';
			} else if (check == 3) {
				text = this.pc.name + '@͋|I';
				this.pc.state += 1;
				this.mode = 'itemSel', num = 0;
			}
			this.textView.pcStatus(this.party.pc[this.pcNum]);
			this.textView.alert(28, 18, 1, 'ǂӒ肵܂H');
			this.pcItemList(0, 14, 0);
			this.textView.alert(24, 14, 1, text);
			this.stop = 1;
			if (View) {
				this.textView.message(14, 12, 'center', viewtext, 'left');
			}
			this.fieldView.update();
			this.selStock = num;
			return;
		}
	} else if (this.mode == 'itemSort') {
		var i;
		for (i = 0; i < this.itemC.length; i++) {
			if (this.itemC[i] == 0) {
				this.itemC[i] = this.itemO[num];
				this.itemCS[i] = this.itemOS[num];
				break;
			}
		}
		this.itemO[num] = 0, this.itemOS[num] = 0;
		for (i = num+1; i < this.itemO.length; i++) {
			this.itemO[i-1] = this.itemO[i];
			this.itemOS[i-1] = this.itemOS[i];
			this.itemO[i] = 0, this.itemOS[i] = 0;
		}
		if (this.itemO[num] == 0) { num--; }
		if (this.itemO[1] == 0) {
			for (i = 0; i < this.itemC.length; i++) {
				if (this.itemC[i] == 0) {
					this.itemC[i] = this.itemO[0];
					this.itemCS[i] = this.itemOS[0];
					this.itemO[0] = 0;
					this.itemOS[0] = 0;
					break;
				}
			}
		}
	}
	this.update(num);
}

// LZ
ItemMode.prototype.cancel = function(num) {
	if (this.mode == 'equipment') {
		this.enter(this.sortO.length - 1);
		return;
	} else if (this.mode == 'equipmentSP') {
		this.selNum++;
		num = 1;
	} else if (this.mode == 'itemSel') {
		this.end();
		return;
	} else if (this.mode == 'itemUse' || this.mode == 'itemDump' || this.mode == 'itemIdentify') {
		this.mode = 'itemSel';
		num = this.selNum;
	} else if (this.mode == 'itemUsePcSel' || this.mode == 'itemUseMapSearch') {
		this.oops = 1, this.mode = 'itemUse';
		num = this.selStock, this.update(num);
		this.textView.alert(20, 6, 1, 'ƁIH');
		this.fieldView.update();
		this.stop = 1;
		return;
	} else if (this.mode == 'itemSort') {
		if (this.itemC[0] == 0) {
			this.mode = 'itemSel';
			num = this.selNum;
		} else {
			var i, j, k, count = 0;
			for (i = 0; i < this.itemC.length; i++) {
				if (this.itemC[i] == 0) {
					this.itemC[i-1] = 0;
					this.itemCS[i-1] = 0;
				}
			}
			this.itemO = new Array(0,0,0,0,0,0,0,0);
			this.itemOS = new Array(0,0,0,0,0,0,0,0);
			for (i = 0; i < this.pc.item.length; i++) {
				k = 1;
				for (j = 0; j < this.itemC.length; j++) {
					if (this.itemC[j] == 0) { break; }
					if (this.pc.item[i] == this.itemC[j]) {
						k = 0;
						break;
					}
				}
				if (k) {
					this.itemO[count] = this.pc.item[i];
					this.itemOS[count] = this.pc.itemS[i];
					count++;
				}
			}
		}
	}
	this.update(num);
}

// L[ꂽƂ
ItemMode.prototype.onKeyPress = function(key) {

	if (key == 'r' || key == 'R') {
		Reset = 1;
		gameMode.init(true);
		return;
	}

	if (this.stop) {
		if (this.mode == 'equipment') {
			this.stop = 0;
			this.selNum++;
			var num = 0
			if (this.selNum > 6) {
				this.mode = 'equipmentSP';
				num = 1;
				this.selNum = 0;
				this.pc.check(this.party.protection);
			}
			this.update(num);
		} else if (this.mode == 'itemUseMapView' || this.mode == 'itemUseMapSearchView') {
			this.stop = 0;
			this.mode = 'itemUseEnd';
			this.itemUse();
		} else if (this.mode == 'itemUse') {
			this.stop = 0, this.oops = 0;
			num = this.selStock;
			this.update(num);
		} else {
			this.stop = 0;
			num = this.selStock;
			this.update(num);
		}
		return;
	}

	if (key == '8' || key == 'u' || key == 'U') {
		if (this.mode == 'itemHand') {
			if (this.selNum2 < 10) {
				this.selNum2--;
				if (this.selNum2 < 0) {
					if (this.sortC.length == 0 && this.sortO.length == 0) {
						this.selNum2 = 10;
					} else if (this.sortC.length == 0) {
						this.selNum2 = this.sortO.length-1;
					} else { this.selNum2 = this.sortC.length + 9; }
				}
			} else {
				this.selNum2--;
				if (this.selNum2 < 10) {
					if (this.sortO.length == 0 && this.sortC.length == 0) {
						this.selNum2 = 0;
					} else if (this.sortO.length == 0) {
						this.selNum2 = this.sortC.length-1 + 9;
					} else { this.selNum2 = this.sortO.length-1; }
				}
			}
			this.update(0);
		} else if (this.mode == 'itemUseMapWarp') {
			this.floor++;
			if (this.floor >= 0) {
				this.floor = FLOOR_MAX * -1;
			}
			this.selectionMode.mapView(this.floor, this.x, this.y, 'map');
		} else if (this.mode == 'itemUseMapWarp_1') {
			this.y++;
			if (this.y >= MAP_SIZE_Y) { this.y = 0; }
			this.selectionMode.mapView_2(this.x, this.y);
		}
	} else if (key == '4' || key == 'h' || key == 'H') {
		if (this.mode == 'itemHand') {
			this.pcNum2--;
			if (this.pcNum2 < 0) { this.pcNum2 = this.ppcLen - 1; }
			if (this.pcNum == this.pcNum2) {
				this.pcNum2--;
				if (this.pcNum2 < 0) {
					this.pcNum2 = this.ppcLen - 1;
				}
			}
			this.pc2 = this.pcModel[this.party.pc[this.pcNum2]];
			this.update(1);
		} else if (this.mode == 'itemUseMapWarp_1') {
			this.x--;
			if (this.x < 0) { this.x = MAP_SIZE_X - 1; }
			this.selectionMode.mapView_2(this.x, this.y);
		}
	} else if (key == '6' || key == 'k' || key == 'K') {
		if (this.mode == 'itemHand') {
			this.pcNum2++;
			if (this.pcNum2 >= this.ppcLen) { this.pcNum2 = 0; }
			if (this.pcNum == this.pcNum2) {
				this.pcNum2++;
				if (this.pcNum2 >= this.ppcLen) {
					this.pcNum2 = 0;
				}
			}
			this.pc2 = this.pcModel[this.party.pc[this.pcNum2]];
			this.update(1);
		} else if (this.mode == 'itemUseMapWarp_1') {
			this.x++;
			if (this.x >= MAP_SIZE_X) { this.x = 0; }
			this.selectionMode.mapView_2(this.x, this.y);
		}
	} else if (key == '2' || key == 'n' || key == 'N') {
		if (this.mode == 'itemHand') {
			if (this.selNum2 < 10) {
				this.selNum2++;
				if (this.selNum2 >= this.sortO.length) {
					if (this.sortC.length == 0 && this.sortO.length == 0) {
						this.selNum2 = 10;
					} else if (this.sortC.length == 0) {
						this.selNum2 = 0;
					} else { this.selNum2 = 10; }
				}
			} else {
				this.selNum2++;
				if (this.selNum2 >= this.sortC.length+10) {
					if (this.sortO.length == 0 && this.sortC.length == 0) {
						this.selNum2 = 0;
					} else if (this.sortO.length == 0) {
						this.selNum2 = 10;
					} else { this.selNum2 = 0; }
				}
			}
			this.update(0);
		} else if (this.mode == 'itemUseMapWarp') {
			this.floor--;
			if (this.floor < FLOOR_MAX * -1) {
				this.floor = -1;
			}
			this.selectionMode.mapView(this.floor, this.x, this.y, 'map');
		} else if (this.mode == 'itemUseMapWarp_1') {
			this.y--;
			if (this.y < 0) { this.y = MAP_SIZE_Y - 1; }
			this.selectionMode.mapView_2(this.x, this.y);
		}
	} else if (key == '5' || key == 'z' || key == 'Z') {
		if (this.mode == 'itemHand') {
			if (this.selNum2 < 10) {
				if (!this.pc.itemS[this.selNum2] && this.sortC.length < 8) {
					this.pc2.getItem(this.pc.item[this.selNum2]);
					this.pc.deleteItem(this.selNum2);
				}
			} else {
				if (!this.pc2.itemS[this.selNum2-10] && this.sortO.length < 8) {
					this.pc.getItem(this.pc2.item[this.selNum2-10]);
					this.pc2.deleteItem(this.selNum2-10);
				}
			}
			this.textView.pcStatus(this.party.pc[this.pcNum]);
			this.update(0);
		} else if (this.mode == 'itemSort') {
			var i;
			for (i = 0; i < this.itemC.length; i++) {
				this.pc.item[i] = this.itemC[i];
				this.pc.itemS[i] = this.itemCS[i];
			}
			this.mode = 'itemSel';
			num = this.selNum;
			this.update(num);
		} else if (this.mode == 'itemUseMapWarp') {
			this.mode = 'itemUseMapWarp_1';
			this.selectionMode.mapView(this.floor, this.x, this.y, 'none');
		} else if (this.mode == 'itemUseMapWarp_1') {
			this.mode = 'itemUseEnd';
			this.itemUse();
		}
	} else if (key == '0' || key == 'x' || key == 'X') {
		if (this.mode == 'itemHand') {
			this.mode = 'itemSel';
			num = this.selNum;
			this.update(num);
		} else if (this.mode == 'itemSort') {
			var i, j, k = 0, count = 0;
			for (i = this.itemC.length-1; i >= 0; i--) {
				if (this.itemC[i] > 0) {
					this.itemC[i] = 0;
					this.itemCS[i] = 0;
					k++;
				}
				if (k == 2) { break; }
			}
			this.itemO = new Array(0,0,0,0,0,0,0,0);
			this.itemOS = new Array(0,0,0,0,0,0,0,0);
			for (i = 0; i < this.pc.item.length; i++) {
				k = 1;
				for (j = 0; j < this.itemC.length; j++) {
					if (this.itemC[j] == 0) { break; }
					if (this.pc.item[i] == this.itemC[j]) {
						k = 0;
						break;
					}
				}
				if (k) {
					this.itemO[count] = this.pc.item[i];
					this.itemOS[count] = this.pc.itemS[i];
					count++;
				}
			}
			num = this.selNum2;
			this.update(num);
		} else if (this.mode == 'itemUseMapWarp') {
			this.oops = 1, this.mode = 'itemUse';
			num = this.selStock, this.update(num);
			this.textView.alert(20, 6, 1, 'ƁIH');
			this.fieldView.update();
			this.stop = 1;
		} else if (this.mode == 'itemUseMapWarp_1') {
			this.mode = 'itemUseMapWarp';
			this.selectionMode.mapView(this.floor, this.x, this.y, 'map');
		}
	} else if (key == '3' || key == 's' || key == 'S') {
		
	} else if (key == '1' || key == 'a' || key == 'A') {
		
	}
}

