// XA

// ^E[hNX
function TownMode(pcModel, partyModel, fieldView, textView, selectionMode, dungeonMode, itemMode) {
	this.pcModel = pcModel;
	this.partyModel = partyModel;
	this.fieldView = fieldView;
	this.textView = textView;
	this.selectionMode = selectionMode;
	this.dungeonMode = dungeonMode;
	this.itemMode = itemMode;
	this.location;
	this.target, this.name, this.race, this.alignment, this.pcClass;
	this.abi = new Array(6);
}

// 
TownMode.prototype.init = function() {
	KeyManager_addListener(this);
	this.start();
}

// Jn
TownMode.prototype.start = function() {
	this.location = 'castleTown';
	this.stop = 0;
	this.selNum = -1, this.selNum2 = -1;

	if (Party >= 0) {
		var pc = this.partyModel[Party].pc;
		var i;

		for (i = pc.length - 1; i >= 0; i--) {
			if (pc[i] > 0) {
				if (this.pcModel[pc[i]].state >= 10) {
					this.pcModel[pc[i]].state -= 10;
				}
				this.pcModel[pc[i]].check();
				if (this.pcModel[pc[i]].state == 7) {
					this.pcDelete(pc[i]);
				} else if (this.pcModel[pc[i]].cantMove) {
					this.partyModel[Party].pcDelete(pc[i]);
				}
			}
		}
	}
	if (MusicOn) { musicStart("CASTLETOWN"); }
	this.update(0);
}

// Õ`FbN
TownMode.prototype.nameCheck = function(name) {
	var i, j;
	if (name == '') { return; }
	if (hanCheck(name)) {
		this.textView.alert(29, 20, 1, 'p͎gpo܂');
		this.fieldView.update();
		this.stop = 1;
		return;
	}
	if (name.length > 6) {
		this.textView.alert(29, 20, 1, 'O͂U܂łł');
		this.fieldView.update();
		this.stop = 1;
		return;
	}
	for (i = 1; i < this.pcModel.length; i++) {
		if (name == this.pcModel[i].name) {
			this.textView.alert(29, 20, 1, 'O̐l܂');
			this.fieldView.update();
			this.stop = 1;
			return;
		}
	}
	for (i = 1; i < this.pcModel.length; i++) {
		if (this.pcModel[i].name == '') {
			this.location = 'trainingCreate_1';
			this.target = i;
			this.name = name;
			this.race = -1, this.alignment = -1, this.pcClass = -1;
			this.nameCheckView(0);
			return;
		}
	}
}

// OύX̃`FbN
TownMode.prototype.changeNameCheck = function(num, name) {
	var i, j;
	if (name == '') { return; }
	if (hanCheck(name)) {
		this.textView.alert(29, 20, 1, 'p͎gpo܂');
		this.fieldView.update();
		this.stop = 1;
		return;
	}
	if (name.length > 6) {
		this.textView.alert(29, 20, 1, 'O͂U܂łł');
		this.fieldView.update();
		this.stop = 1;
		return;
	}
	for (i = 1; i < this.pcModel.length; i++) {
		if (name == this.pcModel[i].name && i != num) {
			this.textView.alert(29, 20, 1, 'O̐l܂');
			this.fieldView.update();
			this.stop = 1;
			return;
		}
	}
	this.pcModel[num].name = name;
	this.location = 'trainingChangeName';
	num = 0;
	if (this.selNum2 >= 0) {
		num = this.selNum2, this.selNum2 = -1;
	}
	this.update(num);
}

// O̊mFʕ\
TownMode.prototype.nameCheckView = function(num) {
	this.fieldView.viewClear();
	this.textView.titleMessage(38, 'P');
	this.createNameView();
	this.textView.alert(30, 18, 1, '̖Oł낵łH');
	var choice = new Array('͂', '');
	this.selectionMode.start(this, choice, 25, 'center', num);
	this.fieldView.update();
}

// pc쐬̖O\
TownMode.prototype.createNameView = function() {
	var i, name = this.name;
	for (i = this.name.length; i < 12; i++) {
		name += '@';
	}
	if (this.race == -1) { name += 'HH'; }
	else { name += abbreviation('race', this.race); }
	if (this.alignment == -1) { name += 'HH'; }
	else { name += '|' + abbreviation('alignment', this.alignment); }
	if (this.pcClass == -1) { name += 'HHHH'; }
	else { name += '|' + abbreviation('pcClass', this.pcClass); }
	name += '@@';
	this.textView.titleMessage(35, name);
}

// 푰Ƃ̃Xe[^X̃Zbg
TownMode.prototype.statusSet = function(num) {
	this.abi[0] = ABILITY[this.race][0], this.abi[1] = ABILITY[this.race][1];
	this.abi[2] = ABILITY[this.race][2], this.abi[3] = ABILITY[this.race][3];
	this.abi[4] = ABILITY[this.race][4], this.abi[5] = ABILITY[this.race][5];

	var tmp;
	this.bonus = 0;
	while(true) {
		if (dice(1,100) < 10) {
			this.bonus += 10;
		} else {
			this.bonus += dice(1, 5) + 4;
			break;
		}
	}
	if (this.bonus > 60) { this.bonus = 60; }
}

// Xe[^X̐ݒ
TownMode.prototype.createStatus = function(num) {
	var status = new Array(7);
	this.textView.messageNonMargin(32, 6, '@@@@@́@@' + hzNum(this.abi[0], 3) + '\n@@@@mb@@' + hzNum(this.abi[1], 3) + '\n@@@MS@@' + hzNum(this.abi[2], 3) + '\n@@@́@@' + hzNum(this.abi[3], 3) + '\n@@@f@@' + hzNum(this.abi[4], 3) + '\n@@^̋@@' + hzNum(this.abi[5], 3) + '\n@@@@@@@@@\n@@{[iX@@' + hzNum(this.bonus, 3));

	var pcClass = this.selClassSet();
	this.textView.messageNonMargin(32, 20, pcClass[0] + '\n' + pcClass[1] + '\n' + pcClass[2] + '\n' + pcClass[3] + '\n' + pcClass[4] + '\n' + pcClass[5] + '\n' + pcClass[6] + '\n' + pcClass[7]);

	var i;
	if (this.location == 'trainingCreate_5') {
		for (i = 0; i < pcClass.length; i++) {
			if (pcClass[i] == '@@@@@@@@@@@@@@@') {
				pcClass[i] = '';
			}
		}
		if (pcClass[num] == '') {
			for (i = 0; i < pcClass.length; i++) {
				if (pcClass[i] != '') {
					num = i;
					break;
				}
			}
		}
		var choice = new Array(pcClass[0], pcClass[1], pcClass[2], pcClass[3], pcClass[4], pcClass[5], pcClass[6], pcClass[7]);
		this.selectionMode.startNon(this, choice, 30, 22, num);
	}
}

// IpNXZbg
TownMode.prototype.selClassSet = function() {
	var pcClass = new Array(8);
	this.cFlag = 0;
	if (this.abi[0] >= 11) {
		pcClass[0] = '@@m@@iej', this.cFlag = 1;
	} else { pcClass[0] = '@@@@@@@@@@@@@@@'; }
	if (this.abi[1] >= 11) {
		pcClass[1] = '@@@gilj', this.cFlag = 1;
	} else { pcClass[1] = '@@@@@@@@@@@@@@@'; }
	if (this.abi[2] >= 11 && this.alignment != 1) {
		pcClass[2] = '@@m@@ioj', this.cFlag = 1;
	} else { pcClass[2] = '@@@@@@@@@@@@@@@'; }
	if (this.abi[4] >= 11 && this.alignment != 0) {
		pcClass[3] = '@@@@isj', this.cFlag = 1;
	} else { pcClass[3] = '@@@@@@@@@@@@@@@'; }
	if (this.abi[1] >= 12 && this.abi[2] >= 12 && this.alignment != 1) {
		pcClass[4] = '@@i@@iaj', this.cFlag = 1;
	} else { pcClass[4] = '@@@@@@@@@@@@@@@'; }
	if (this.abi[0] >= 15 && this.abi[1] >= 11 && this.abi[2] >= 10 && this.abi[3] >= 14 && this.abi[4] >= 10 && this.alignment != 2) {
		pcClass[5] = '@@@@@irj', this.cFlag = 1;
	} else { pcClass[5] = '@@@@@@@@@@@@@@@'; }
	if (this.abi[0] >= 15 && this.abi[1] >= 12 && this.abi[2] >= 12 && this.abi[3] >= 15 && this.abi[4] >= 14 && this.abi[5] >= 15 && this.alignment == 0) {
		pcClass[6] = '@@N@@ikj', this.cFlag = 1;
	} else { pcClass[6] = '@@@@@@@@@@@@@@@'; }
	if (this.abi[0] >= 15 && this.abi[1] >= 17 && this.abi[2] >= 15 && this.abi[3] >= 16 && this.abi[4] >= 15 && this.abi[5] >= 16 && this.alignment == 2) {
		pcClass[7] = '@@Eҁ@@imj', this.cFlag = 1;
	} else { pcClass[7] = '@@@@@@@@@@@@@@@'; }

	return pcClass;
}

// pcXg\
TownMode.prototype.pcList = function(num, mode) {
	if (this.pcModel[1].name == '' && mode == 'delete') {
		this.fieldView.viewClear();
		this.textView.titleMessage(38, 'P');
		this.location = 'trainingDelete_2';
		this.textView.alert(32, 18, 1, '܂H');
		var choice = new Array('͂', '');
		this.selectionMode.start(this, choice, 27, 'center', num);
		return;
	}
	if (this.pcModel[1].name == '') {
		this.textView.alert(29, 20, 1, 'N܂');
		this.stop = 1;
		this.location = 'training';
		return;
	}

	this.fieldView.viewClear();
	this.textView.titleMessage(38, 'P');

	if (mode == 'inspect') {
		this.textView.alert(33, 18, 1, 'N܂H');
	} else if (mode == 'delete') {
		this.textView.alert(33, 18, 1, 'N𖕏܂H');
	} else if (mode == 'changeName') {
		this.textView.alert(33, 18, 1, 'N̖OύX܂H');
	} else if (mode == 'changeClass') {
		this.textView.alert(33, 18, 1, 'N]E܂H');
	}
	this.textView.textFrameNonMargin(35, this.pcModel.length + 1);
	var i, y = this.pcModel.length - 1, name;
	var choice = new Array(this.pcModel.length - 1);
	this.sortO = new Array(0);
	for (i = 1; i < this.pcModel.length; i++) { choice[i-1] = ''; }
	for (i = 1; i < this.pcModel.length; i++) {
		if (this.pcModel[i].name == '') { break; }
		choice[i-1] = '1';
		this.sortO[i-1] = 1;
		name = this.pcListNameSet(i);
		this.textView.write(3, y, name);
		y--;
	}
	this.textView.textSet('center', 29, 29 - this.pcModel.length);
	this.selectionMode.startNonD(this, choice, 28, 5, 32, num);
}

// pcĊJpXg\
TownMode.prototype.pcRestartList = function(num) {

	if (this.sortO.length == 0) {
		this.textView.alert(29, 20, 1, '{ɂ͒N܂');
		this.stop = 1;
		this.location = 'edgeOfTown';
		this.selNum2 = 0;
		return;
	}

	this.fieldView.viewClear();
	this.textView.titleMessage(38, 'O');

	this.textView.alert(33, 18, 1, '`̍ĊJ');

	this.textView.textFrameNonMargin(35, this.pcModel.length + 1);
	var i, y = this.pcModel.length - 1, name;
	for (i = 0; i < this.sortO.length; i++) {
		name = this.pcListNameSet(this.sortO[i]);
		this.textView.write(3, y, name);
		y--;
	}
	this.textView.textSet('center', 29, 29 - this.pcModel.length);
	this.selectionMode.startNonD(this, this.sortO, 28, 5, 32, num);
}

// ёւppcXg\
TownMode.prototype.pcSortList = function(num) {
	if (this.pcModel[1].name == '') {
		this.textView.alert(29, 20, 1, 'N܂');
		this.stop = 1;
		this.location = 'training';
		return;
	}

	this.textView.textFrameNonMargin(35, this.pcModel.length + 1);
	var i, j, y = this.pcModel.length - 1, name;
	if (this.sortO[0] > 0) {
		for (i = 0; i < this.sortO.length; i++) {
			if (this.sortO[i] == 0) { break; }
			name = this.pcListNameSet(this.sortO[i]);
			this.textView.write(3, y, name);
			y--;
		}
	}
	this.textView.textSet('center', 39, 39 - this.pcModel.length);

	this.textView.textFrameNonMargin(35, this.pcModel.length + 1);
	y = this.pcModel.length - 1;
	if (this.sortC[0] > 0) {
		for (i = 0; i < this.sortC.length; i++) {
			if (this.sortC[i] == 0) { break; }
			name = hzNum(i+1, 0) + 'F';
			name += this.pcListNameSet(this.sortC[i]);
			if (i < 9) { this.textView.write(1, y, name); }
			else { this.textView.write(0, y, name); }
			y--;
		}
	}
	this.textView.textSet('center', 19, 19 - this.pcModel.length);

	this.selectionMode.startNonD(this, this.sortO, 38, 5, 32, num);
}

// p[eB[ǉppcXgf[^쐬
TownMode.prototype.pcAddListCreate = function() {
	var i, j, alignment, pc = this.pcModel;
	this.alignment = 1;
	if (Party >= 0) {
		var party = this.partyModel[Party];
		for (i = 0; i < party.pc.length; i++) {
			if (party.pc[i] > 0) {
				if (pc[party.pc[i]].alignment == 0) {
					this.alignment = 0;
					break;
				} else if (pc[party.pc[i]].alignment == 2) {
					this.alignment = 2;
					break;
				}
			} else { break; }
		}
	}
	this.sortO = new Array(0);
	j = 0;
	for (i = 1; i < pc.length; i++) {
		if (pc[i].name == '') { break; }
		if (this.alignment == 0 && pc[i].alignment == 2) {
			continue;
		} else if (this.alignment == 2 && pc[i].alignment == 0) {
			continue;
		}
		if (pc[i].party < 0) {
			this.sortO[j] = i;
			j++;
		}
	}
}

// p[eB[ǉppcXg\
TownMode.prototype.pcAddList = function(num) {
	this.fieldView.viewClear();
	this.textView.titleMessage(38, TAVERN);
	this.textView.alert(33, 18, 1, 'N𒇊Ԃɓ܂H');
	this.textView.textFrameNonMargin(35, this.pcModel.length + 1);

	var y = this.pcModel.length - 1, name;
	for (i = 0; i < this.sortO.length; i++) {
		name = this.pcListNameSet(this.sortO[i]);
		this.textView.write(3, y, name);
		y--;
	}

	this.textView.textSet('center', 29, 29 - this.pcModel.length);
	if (this.sortO.length - 1 < num) {
		num = this.sortO.length - 1;
	}
	this.selectionMode.startNonD(this, this.sortO, 28, 5, 32, num);
	this.textView.partyStatus();
}

// pcXgpOZbg
TownMode.prototype.pcListNameSet = function(num) {
	var i, j, name = this.pcModel[num].name;
	for (i = name.length; i < 8; i++) { name += '@'; }
	name += 'k';
	name += hzNum(this.pcModel[num].level, 0);
	if (this.pcModel[num].level < 10) { name += '@@@@'; }
	else if (this.pcModel[num].level < 100) { name += '@@@'; }
	else if (this.pcModel[num].level < 1000) { name += '@@'; }
	else { name += '@'; }
	name += abbreviation('race', this.pcModel[num].race);
	name += '|' + abbreviation('alignment', this.pcModel[num].alignment);
	name += '|' + abbreviation('pcClass', this.pcModel[num].pcClass);

	name += '@';
	if (this.pcModel[num].party >= 0) {
		var state = this.pcModel[num].state;
		if (state >= 10) { state -= 10; }
		if (state == 3) { name += 'Ⴡ^n'; }
		else if (state == 4) { name += '΁^n'; }
		else if (state == 5) { name += '^n'; }
		else if (state == 6) { name += 'D^n'; }
		else if (state == 7) { name += 'Ł^n'; }
		else { name += 'nts'; }
		var pName = new Array('`','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q');
		name += '@' + pName[this.pcModel[num].party];
	} else {
		var state = this.pcModel[num].state;
		if (state >= 10) { state -= 10; }
		if (state >= 3) {
			name += '@' + abbreviation('state', state);
		}
	}

	return name;
}

// pc\[g
TownMode.prototype.pcSort = function(num) {
	var i;
	for (i = 0; i < this.sortC.length; i++) {
		if (this.sortC[i] == 0) {
			this.sortC[i] = this.sortO[num];
			break;
		}
	}
	if (num == this.sortO.length - 1) {
		this.sortO[num] = 0;
	}
	for (i = num + 1; i < this.sortO.length; i++) {
		this.sortO[i-1] = this.sortO[i];
		this.sortO[i] = 0;
	}
}

// pc\[gLZ
TownMode.prototype.pcSortCancel = function() {
	var i, last, insert;
	for (i = 1; i < this.sortC.length; i++) {
		if (this.sortC[i] == 0) {
			last = i-1;
			break;
		}
	}
	for (i = 0; i < this.sortO.length; i++) {
		if(this.sortO[i] > this.sortC[last] || this.sortO[i] == 0) {
			insert = i;
			break;
		}
	}
	if (insert == this.sortO.length - 1) {
		this.sortO[insert] = this.sortC[last];
		this.sortC[last] = 0;
		return;
	}
	for (i = this.sortO.length - 1; i > insert; i--) {
		this.sortO[i] = this.sortO[i-1];
		this.sortO[i-1] = 0;
	}
	this.sortO[insert] = this.sortC[last];
	this.sortC[last] = 0;
}

// pc\[g
TownMode.prototype.pcSortSet = function() {
	var i, j, tmp;
	for (i = 0; i < this.sortO.length; i++) { this.sortO[i] = i + 1; }
	for (i = 0; i < this.sortC.length; i++) {
		for (j = i; j < this.sortO.length; j++) {
			if (this.sortC[i] == this.sortO[j]) {
				if (j == i) { break; }
				pcCopy(i+1, 0);
				pcCopy(j+1, i+1);
				pcCopy(0, j+1);
				tmp = this.sortO[i];
				this.sortO[i] = this.sortO[j];
				this.sortO[j] = tmp;
				break;
			}
		}
	}
}

// pco^
TownMode.prototype.pcEnter = function() {
	document.f.t.value = '';
	var pc = this.pcModel[this.target];
	pc.name = this.name, pc.race = this.race;
	pc.alignment = this.alignment, pc.pcClass = this.pcClass;
	pc.abi[0] = this.abi[0], pc.abi[1] = this.abi[1];
	pc.abi[2] = this.abi[2], pc.abi[3] = this.abi[3];
	pc.abi[4] = this.abi[4], pc.abi[5] = this.abi[5];
	pc.gold = dice(1, 100) + 150;
	pc.ageWeek = dice(1, 200) + 100;
	pc.check();
	pc.levelUpSpell();
	var i;
	for (i = 0; i < pc.mpM.length; i++) {
		pc.mpM[i] = pc.mpMMax[i];
		pc.mpP[i] = pc.mpPMax[i];
	}
	pc.hpMax = pc.levelUpHp(), pc.hp = pc.hpMax;
}

// pc폜
TownMode.prototype.pcDelete = function(pcNum) {
	var i, j, pc = this.pcModel;
	if (pc[pcNum].party >= 0) {
		this.partyModel[pc[pcNum].party].pcDelete(pcNum);
	}
	pc[pcNum].init();
	for (i = pcNum + 1; i < pc.length; i++) {
		if (pc[i].name == '') { break; }
		pcCopy(i, i - 1);
		pc[i].init();
	}
	for (i = 0; i < this.partyModel.length; i++) {
		for (j = 0; j < this.partyModel[i].pc.length; j++) {
			if (this.partyModel[i].pc[j] > pcNum) {
				this.partyModel[i].pc[j]--;
			}
		}
	}
}

// p[eB[pcI
TownMode.prototype.pcSel = function(num, mode) {
	if (Party < 0) {
		this.textView.alert(29, 20, 1, 'p[eB[ɒN܂');
		this.stop = 1;
		this.location = 'tavern';
		this.selNum2 = 0;
		return;
	}

	if (mode == 'delete') {
		this.textView.alert(32, 18, 1, 'NO܂H');
	} else if (mode == 'inspect') {
		this.textView.alert(32, 18, 1, 'N𒲂ׂ܂H');
	} else if (mode == 'inn') {
		this.textView.alert(32, 18, 1, 'N܂܂H');
	} else if (mode == 'shop') {
		this.textView.alert(32, 18, 1, 'N܂H');
	}

	this.partyModel[Party].check();
	var i, pc = this.partyModel[Party].pc;
	this.sortO = new Array(0);
	for (i = 0; i < pc.length; i++) {
		if (pc[i] > 0) { this.sortO[i] = pc[i]; }
		else { break; }
	}
	if (this.sortO.length <= num) {
		num--;
		if (num < 0) { num = 0; }
	}
	this.textView.partyStatus();
	this.selectionMode.startNon(this, this.sortO, 6, 4, num);

}

// R
TownMode.prototype.divide = function(num) {
	var i, divide = 0, gold = 0, pc = this.partyModel[num].pc;
	var tmp, remainder;
	for (i = 0; i < pc.length; i++) {
		if (pc[i] > 0) {
			divide++;
			gold += this.pcModel[pc[i]].gold;
		}
	}
	if (gold > 999999999999) { gold = 999999999999; }
	remainder = gold % divide;
	tmp = Math.floor(gold / divide);

	this.pcModel[pc[0]].gold = tmp + remainder;
	for (i = 1; i < pc.length; i++) {
		if (pc[i] > 0) {
			this.pcModel[pc[i]].gold = tmp;
		}
	}
}

// xAbv
TownMode.prototype.levelUp = function(num) {
	var i, tmp, dead = 0, pc = this.pcModel[num];
	this.fieldView.viewClear();
	this.textView.titleMessage(38, INN);
	this.textView.partyStatus();

	pc.check();
	for (i = 0; i < pc.abi.length; i++) {
		if (pc.abi[i] <= 2) {
			dead = 1;
			break;
		}
	}
	if (!dead) {
		if (pc.age >= 100) {
			tmp = pc.age - 90;
			if (dice(1,100) <= tmp) { dead = 1; }
		}
	}
	if (dead) {
		this.textView.message(35, 24, 'center', pc.name + '͘Vŗ͐sB', 'cneter');
	}

	if (pc.next > 0 && !dead) {
		this.textView.message(35, 24, 'center', '̃xɂ́A\n@@@' + hzNum(pc.next, 12) + '@dwoKvłB', 'left');
	} else if (!dead) {
		var text = pc.name + '̓x' + hzNum(pc.level+1, 0) + 'ɔF肳܂I\n\n';
		var up = pc.levelUp();
		for (i = 0; i < 8; i++) {
			if (i < up.length) { text += up[i] + '\n'; }
			else { text += '\n'; }
		}
		this.textView.message(35, 24, 'center', text, 'left');
		if (SeOn) { seSounded("LEVELUP"); }
	}

	if (dead) {
		this.pcDelete(num);
	} else {
		for (i = 0; i < pc.mpM.length; i++) {
			pc.mpM[i] = pc.mpMMax[i];
			pc.mpP[i] = pc.mpPMax[i];
		}
	}
	this.textView.partyStatus();
	this.fieldView.update();
	return dead;
}

// hinȊOj
TownMode.prototype.innBed = function() {
	this.fieldView.viewClear();
	this.textView.titleMessage(38, INN);
	var pc = this.pcModel[this.partyModel[Party].pc[this.selNum]];
	this.week++;
	pc.ageWeek++;
	pc.gold -= this.charge;
	pc.hpCtrl(this.hpPlus);
	this.textView.partyStatus();
	this.textView.message(35, 28, 'center', pc.name + '̗͉̑͂񕜂Ă\n\n@@@@@@@@@' + hzNum(this.week, 4) + '@T\n\n@@@@go@i@@' + hzNum(pc.hp, 4) + '^' + hzNum(pc.hpMax, 4) + '@@j\n\n@@@@i@' + hzNum(pc.gold, 12) + 'j', 'left');
	this.fieldView.update();
}

// ]E\
TownMode.prototype.changeClass = function(num) {
	this.fieldView.viewClear();
	this.textView.pcStatus(this.selNum2+1);
	this.textView.titleMessage(38, '@]E@');
	var i, tmp, pc = this.pcModel[this.selNum2+1];
	for (i = 0; i < pc.abi.length; i++) { this.abi[i] = pc.abi[i]; }
	this.alignment = pc.alignment;
	var pcClass = this.selClassSet();
	pcClass[pc.pcClass] = '@@@@@@@@@@@@@@@';
	this.textView.messageNonMargin(27, 23, pcClass[0] + '\n' + pcClass[1] + '\n' + pcClass[2] + '\n' + pcClass[3] + '\n' + pcClass[4] + '\n' + pcClass[5] + '\n' + pcClass[6] + '\n' + pcClass[7]);
	for (i = 0; i < pcClass.length; i++) {
		if (pcClass[i] == '@@@@@@@@@@@@@@@') {
			pcClass[i] = '';
		}
	}
	if (pcClass[num] == '') {
		for (i = 0; i < pcClass.length; i++) {
			if (pcClass[i] != '') {
				num = i;
				break;
			}
		}
	}
	var choice = new Array(pcClass[0], pcClass[1], pcClass[2], pcClass[3], pcClass[4], pcClass[5], pcClass[6], pcClass[7]);
	tmp = pcClass[0];
	for (i = 1; i < pcClass.length; i++) { tmp += pcClass[i]; }
	if (tmp == '') {
		this.textView.alert(22, 20, 1, ']EłEƂ܂');
		this.stop = 1;
	} else {
		this.selectionMode.startNon(this, choice, 25, 25, num);
	}
}

// pX[h̃`FbN
TownMode.prototype.passCheck = function() {
	var val = document.f.t.value;
	document.f.t.value = '';
	val = retDeleted(val);
	val = val.replace(/ /g, '');

	var text;
	var h = val.charAt(0) + val.charAt(1) + val.charAt(2);
	var t = val.charAt(val.length-3) + val.charAt(val.length-2) + val.charAt(val.length-1);
	if (val == '' || val == null || h != '7Za' || t != '2fG') {
		text = '\npX[hႢ܂B\n';
		document.f.t.value = val;
	} else {
		val = val.replace(/^7Za/, '');
		val = val.replace(/2fG$/, '');
		val = base64decode(val);
		val = zip_inflate(val);
		val = utf8to16(val);

		var mOn = MusicOn, sOn = SeOn;
		if (loadDataSet(this.pcModel, this.partyModel, val)) {
			text = '\npX[h͂܂B\n';
			var i, j, party = this.partyModel;
			for (i = 0; i < party.length; i++) {
				if (party[i].floor == 0 && party[i].pc[0] > 0) {
					for (j = party[i].pc.length - 1; j >= 0; j--) {
						if (party[i].pc[j] > 0) {
							party[i].pcDelete(party[i].pc[j]);
						}
					}
				}
				break;
			}
			Party = -1;
			this.textView.partyStatus();
			if (!Ie) { MusicOn = 0, SeOn = 0; }
			else { MusicOn = mOn, SeOn = sOn; }
		} else { text = '\npX[hႢ܂B\n'; }
	}
	this.stop = 1;
	this.textView.message(30, 20, 'center', text, 'center');
	this.fieldView.update();
}

// Xpc\
TownMode.prototype.shopPc = function() {
	var i, text, pc = this.pcModel[this.pcNum];
	text = 'ႢA' + pc.name + '';
	for (i = text.length; i < 18; i++) { text += '@'; }
	if (pc.action[0] == 0) {
		text += 'st';
		if (pc.action[1] == 0) { text += '@'; }
		else if (pc.action[1] == 1) { text += '@Z'; }
		else if (pc.action[1] == 2) { text += '@'; }
		else if (pc.action[1] == 3) { text += '@'; }
		else if (pc.action[1] == 4) { text += '@'; }
		else if (pc.action[1] == 5) { text += '@̑'; }
	}
	else if (pc.action[0] == 1) { text += 'st'; }
	else if (pc.action[0] == 2) { text += 's􂢂t'; }
	else if (pc.action[0] == 3) { text += 'sӒt'; }
	text += '\n\n@@@@@' + hzNum(pc.gold, 12) + '@fo';
	this.textView.message(36, 26, 'center', text, 'left');
}

// X̏iXg擾
TownMode.prototype.shopMenuSet = function(num) {
	var i = 0, j = 1, item;
	num++;
	this.sortO = new Array(0);
	while (true) {
		item = itemData(j);
		if (item[0] == 0 || j >= 1000) { break; }
		else {
			if (item[0] == num) {
				this.sortO[i] = j;
				i++;
			}
		}
		j++;
	}
}

// X̏iXg\
TownMode.prototype.shopMenuView = function(move) {
	this.textView.textFrameNonMargin(42, 24);
	var i, j, y = 20, item, text, data, point;
	var pc = this.pcModel[this.pcNum];
	var tmp = this.sortO.length;

	if (tmp <= y) {
		if (this.selNum2 < 0) {
			if (move == 'left') { this.selNum2 = 0; }
			else { this.selNum2 = this.sortO.length-1; }
		} else if (this.selNum2 >= this.sortO.length) {
			if (move == 'right') {
				this.selNum2 = this.sortO.length-1;
			} else { this.selNum2 = 0; }
		}
	} else {
		if (this.selNum2 < 0) { this.selNum2 += this.sortO.length; }
		else if (this.selNum2 >= this.sortO.length) {
			this.selNum2 -= this.sortO.length;
		}
		tmp = y;
		this.textView.write(3, y+2, '@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@');
		this.textView.write(3, 1, '@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@');
		i = this.listNum;
		j = 0;
		var ok = 0;
		while (true) {
			if (j >= tmp) { break; }
			if (i >= this.sortO.length) { i = 0; }
			if (i == this.selNum2) {
				ok = 1;
				break;
			}
			i++;
			j++;
		}
		if (!ok) {
			if (move == 'up') { this.listNum--; }
			else if (move== 'down') { this.listNum++; }
			else if (move == 'left') { this.listNum -= 6; }
			else if (move == 'right') { this.listNum += 6; }
			if (this.listNum < 0) {
				this.listNum += this.sortO.length;
			} else if (this.listNum >= this.sortO.length) {
				this.listNum -= this.sortO.length;
			}
		}
	}

	var list = new Array(tmp);
	i = this.listNum;
	j = 0;
	while (true) {
		if (j >= list.length) { break; }
		if (i >= this.sortO.length) { i = 0; }
		if (i == this.selNum2) { point = j; }
		list[j] = this.sortO[i];
		i++;
		j++;
	}
	for (i = 0; i < list.length; i++) {
		item = itemData(list[i]);
		if (point == i) { text = ''; }
		else { text = '@'; }
		if (ItemStock[list[i]-1] > 0) {
			if (item[3] == 0) { text += '@@'; }
			else {
				data = NtoP(item[3]);
				if (data[pc.pcClass]) { text += '@@'; }
				else { text += '@'; }
			}
			text += item[1];
			for (j = text.length; j < 26; j++) { text += '@'; }
			text += hzNum(item[11], 12);
		} else {
			text += '@@@@@@@@@@@@rnkc@nts@@@@@@@@@@@@@';
		}
		if (point == i) { text += '@'; }
		this.textView.write(1, y+1, text);
		y--;
	}

	this.textView.textSet('center', 27, 4);
}

// XłpcACeXg\
TownMode.prototype.shopPcItem = function(mode, num) {
	var i, j, y = 8, item, text, choice = new Array(0);
	var pc = this.pcModel[this.pcNum];
	this.textView.textFrameNonMargin(38, 10);
	for (i = 0; i < pc.item.length; i++) {
		if (pc.item[i] == 0) { break; }
		text = itemStr(pc.item[i], pc.itemS[i], pc.alignment, pc.pcClass);
		for (j = text.length; j < 20; j++) { text += '@'; }
		item = itemData(pc.item[i]);
		if (pc.action[0] == 1) {
			if (pc.item[i] >= 10000 && pc.item[i]-10000 < 1000) {
				text += hzNum(1, 12);
			} else {
				text += hzNum(Math.floor(item[11] / 2), 12);
			}
		} else if (pc.action[0] == 2) {
			var curse = NtoP(item[4]);
			if (pc.itemS[i] && curse[pc.alignment]) {
				text += hzNum(Math.floor(item[11] / 2), 12);
			} else { text += hzNum(0, 12); }
		} else if (pc.action[0] == 3) {
			if (pc.item[i] >= 10000) {
				text += hzNum(Math.floor(item[11] / 2), 12);
			} else { text += hzNum(0, 12); }
		}
		this.textView.write(3, y, text);
		choice[i] = 1;
		y--;
	}
	this.textView.textSet('center', 27, 18);
	if (mode == 1) {
		if (num >= choice.length) { num--; }
		this.selectionMode.startNonD(this, choice, 26, 4, 35, num);
	}
}

// Xł̃ACe̔AAӒ
TownMode.prototype.shopItem = function(num) {
	var pc = this.pcModel[this.pcNum];
	var itemNum = pc.item[pc.action[1]];
	var tmp = itemNum;
	if (tmp >= 10000) { tmp -= 10000; }
	var item = itemData(itemNum), curse = NtoP(item[4]);
	var text = '';
	if (pc.action[0] == 1) {
		if (tmp >= 1000) {
			text = 'Ȃ̂ɂ͋܂';
		} else if (pc.itemS[pc.action[1]] && curse[pc.alignment]) {
			text = '􂢂͔̂̂܂';
		} else if (pc.itemS[pc.action[1]]) {
			this.textView.message(28, 26, 'center', 'gɕtĂ̂łA܂H\n\n@͂\n@@', 'center');
			var choice = new Array(1,1);
			this.selectionMode.startNon(this, choice, 23, 19, num);
		} else {
			if (itemNum >= 10000) { pc.gold += 1; }
			else { pc.gold += Math.floor(item[11] / 2); }
			var tmp = pc.item[pc.action[1]]-1;
			if (ItemStock[tmp] < 31) { ItemStock[tmp]++; }
			pc.deleteItem(pc.action[1]);
			pc.check();
			this.shopPc();
			this.shopPcItem(0, 0);
			text = 'Ɍp͂܂񂩁H';
		}
		if (text != '') {
			this.textView.alert(25, 26, 1, text);
			this.selNum2 = pc.action[1];
			pc.action[1] = -1;
			this.stop = 1;
		}
	} else if (pc.action[0] == 2) {
		var curse = NtoP(item[4]);
		if (pc.itemS[pc.action[1]] && curse[pc.alignment]) {
			if (pc.gold < Math.floor(item[11] / 2)) {
				text = 'Ȃ̏ł͕܂';
			} else {
				pc.gold -= Math.floor(item[11] / 2);
				pc.deleteItem(pc.action[1]);
				pc.check();
				this.shopPc();
				this.shopPcItem(0, 0);
				text = 'Ɍp͂܂񂩁H';
			}
		} else { text = 'ɂ͎􂢂͂Ă܂'; }
		if (text != '') {
			this.textView.alert(25, 26, 1, text);
			this.selNum2 = pc.action[1];
			pc.action[1] = -1;
			this.stop = 1;
		}
	} else if (pc.action[0] == 3) {
		if (pc.item[pc.action[1]] >= 10000) {
			if (pc.gold < Math.floor(item[11] / 2)) {
				text = 'Ȃ̏ł͕܂';
			} else {
				pc.gold -= Math.floor(item[11] / 2);
				pc.item[pc.action[1]] -= 10000;
				this.shopPc();
				this.shopPcItem(0, 0);
				text = 'Ɍp͂܂񂩁H';
			}
		} else { text = '͉ł邩Ałɂ킩Ă܂'; }
		if (text != '') {
			this.textView.alert(25, 26, 1, text);
			this.selNum2 = pc.action[1];
			pc.action[1] = -1;
			this.stop = 1;
		}
	}
}

// ʕ\
TownMode.prototype.update = function(num) {
	if (this.location == 'castleTown') {
		this.fieldView.viewClear();
		this.textView.titleMessage(38, '鉺F');
		var choice = new Array(TAVERN, INN, SHOP, TEMPLE, CASTLE, 'Oɍs@@@@');
		this.selectionMode.start(this, choice, 34, 'center', num);
		this.textView.partyStatus();
	} else if (this.location == 'edgeOfTown') {
		this.fieldView.viewClear();
		this.textView.titleMessage(38, 'O');
		var choice = new Array('{ɓ', '`̍ĊJ', 'P', 'pX[h', '鉺ɖ߂@');
		this.selectionMode.start(this, choice, 34, 'center', num);
		this.textView.partyStatus();
	} else if (this.location == 'maze') {
		if (Party >= 0) {
			this.fieldView.viewClear();
			this.textView.titleMessage(38, 'O');
			this.textView.message(36, 30, 'center', 'd\n\n' + SUBTITLE, 'center');
			this.textView.partyStatus();
			this.stop = 1;
		} else {
			this.textView.alert(29, 20, 1, 'p[eB[ɒN܂');
			this.stop = 1;
			this.location = 'edgeOfTown';
			this.selNum2 = 0;
		}
	} else if (this.location == 'restart') {
		this.pcRestartList(num);
	} else if (this.location == 'training') {
		this.fieldView.viewClear();
		this.textView.titleMessage(38, 'P');
		var choice = new Array('`҂o^@', '`҂', '`҂𖕏', 'OύX', ']E', 'בւ', 'Oɖ߂');
		this.selectionMode.start(this, choice, 34, 'center', num);
	} else if (this.location == 'trainingCreate') {
		if (this.pcModel[this.pcModel.length-1].name != '') {
			this.location = 'training';
			this.selNum2 = 0;
			this.textView.alert(29, 20, 1, 'Pꂪł');
			this.stop = 1;
		} else {
			this.fieldView.viewClear();
			this.textView.titleMessage(38, 'P');
			var name = prompt("ÓH", "");
			if (name == null || name == '') {
				this.location = 'training';
				this.update(0);
				return;
			} else {
				if(Ie){
					var res = escape(name);
					var pos = res.indexOf("%00");
					if(pos != -1){ res = res.substr(0,pos); }
					name = unescape(res);
				}
				this.nameCheck(name);
				return;
			}
		}
	} else if (this.location == 'trainingCreate_2') {
		this.fieldView.viewClear();
		this.textView.titleMessage(38, 'P');
		this.createNameView();
		var choice = new Array('lԁ@@igj', 'Gt@idj', 'h[ticj', 'm[@ifj', 'zrbgigj');
		this.selectionMode.start(this, choice, 30, 10, num);
	} else if (this.location == 'trainingCreate_3') {
		this.createNameView();
		var choice = new Array('P@ifj', 'imj', '@idj');
		this.selectionMode.start(this, choice, 26, 16, num);
	} else if (this.location == 'trainingCreate_4') {
		this.createNameView();
		if (this.gFlag) {
			this.statusSet();
			this.gFlag = 0;
		}
		this.createStatus(num);
		var choice = new Array('1', '1', '1', '1', '1', '1');
		this.selectionMode.startNon(this, choice, 30, 15, num);
	} else if (this.location == 'trainingCreate_5') {
		this.createStatus(num);
	} else if (this.location == 'trainingCreate_6') {
		this.fieldView.viewClear();
		this.textView.titleMessage(38, 'P');
		this.createNameView();
		this.textView.alert(30, 18, 1, '̖`҂g܂H');
		var choice = new Array('͂', '');
		this.selectionMode.start(this, choice, 25, 'center', num);
	} else if (this.location == 'trainingInspect') {
		this.pcList(num, 'inspect');
	} else if (this.location == 'trainingInspect_1') {
		this.fieldView.viewClear();
		this.textView.pcStatus(this.sortO[num]);
	} else if (this.location == 'trainingDelete') {
		this.pcList(num, 'delete');
	} else if (this.location == 'trainingDelete_1') {
		this.textView.alert(33, 20, 1, 'w' + this.pcModel[num+1].name + 'x𖕏܂H');
		var choice = new Array('͂', '');
		this.selectionMode.start(this, choice, 28, 'center', 0);
	} else if (this.location == 'trainingDelete_2') {
		this.pcList(num, 'delete');
	} else if (this.location == 'trainingChangeName') {
		this.pcList(num, 'changeName');
	} else if (this.location == 'trainingChangeName_1') {
		this.fieldView.viewClear();
		this.textView.titleMessage(38, 'P');
		var name = prompt("ÓH", this.pcModel[num + 1].name);
		if (name == null || name == '') {
			this.location = 'trainingChangeName';
			num = 0;
			if (this.selNum2 >= 0) {
				num = this.selNum2, this.selNum2 = -1;
			}
			this.update(num);
			return;
		} else {
			if(Ie){
				var res = escape(name);
				var pos = res.indexOf("%00");
				if(pos != -1){ res = res.substr(0,pos); }
				name = unescape(res);
			}
			this.changeNameCheck(this.selNum2 + 1, name);
			return;
		}
	} else if (this.location == 'trainingChangeClass') {
		this.pcList(num, 'changeClass');
	} else if (this.location == 'trainingChangeClass_1') {
		this.changeClass(num);
	} else if (this.location == 'trainingChangeClass_2') {
		this.textView.message(30, 20, 'center', 'u' + abbreviation('pcClass2', this.pcClass) + 'vɓ]E܂B\n\n낵łH\n\n\n@@͂\n@@@', 'center');
		var choice = new Array('1', '1');
		this.selectionMode.startNon(this, choice, 22, 20, num);
	} else if (this.location == 'trainingSort') {
		this.pcSortList(num);
	} else if (this.location == 'pass') {
		var choice = new Array('\', '');
		this.selectionMode.start(this, choice, 28, 19, num);
	} else if (this.location == 'passView') {
		var val = saveDataCreate(this.pcModel, this.partyModel);
		var i, result;
		val = utf16to8(val);
		val = zip_deflate(val);
		val = base64encode(val);
		val = '7Za' + val + '2fG';
		result = val.charAt(0);
		for (i = 1; i < val.length; i++) {
			result += val.charAt(i);
			if ((i % 50) == 0) { result += '\n'; }
		}
		document.f.t.value = result;
		this.textView.message(30, 22, 'center', 'ʉ̃tH[ɃpX[h\Ă܂B\n\n߂ɂ́ALZL[ĂB', 'center');
	} else if (this.location == 'passInput') {
		this.textView.message(30, 20, 'center', 'ʉ̃tH[ɃpX[h͂A\n\n̓{^NbNĂB', 'center');
	} else if (this.location == 'tavern') {
		this.fieldView.viewClear();
		this.textView.titleMessage(38, TAVERN);
		var choice = new Array('Ԃɓ', 'ԂO', 'ׂ', 'R', 'O֏o');
		this.selectionMode.start(this, choice, 34, 'center', num);
		this.textView.partyStatus();
	} else if (this.location == 'tavernAdd') {
		if (Party >= 0) {
			if (this.partyModel[Party].pc[5] > 0) {
				this.textView.alert(29, 20, 1, 'p[eB[tł');
				this.stop = 1;
				this.selNum2 = 0;
				this.location = 'tavern';
			}
		}
		if (this.location == 'tavernAdd' && this.sortO.length == 0) {
			this.textView.alert(29, 20, 1, 'N܂');
			this.stop = 1;
			this.selNum2 = 0;
			this.location = 'tavern';
		}
		if (this.location == 'tavernAdd') { this.pcAddList(num); }
	} else if (this.location == 'tavernDelete') {
		this.pcSel(num, 'delete');
	} else if (this.location == 'tavernInspect') {
		this.pcSel(num, 'inspect');
	} else if (this.location == 'tavernInspect_1') {
		this.fieldView.viewClear();
		this.textView.pcStatus(this.sortO[this.pcNum]);
		var i, tmp, count = 0, item;
		var pc = this.pcModel[this.sortO[this.pcNum]];
		this.com = new Array(0);
		this.com[count] = 0, count++;
		tmp = 0;
		for (i = 0; i < 8; i++) {
			item = itemData(pc.item[i]);
			if (item[3] > 0) {
				tmp = 1;
				break;
			}
		}
		if (tmp) { this.com[count] = 1, count++; }
		this.com[count] = 2, count++;
		this.com[count] = 3;
		var choice = new Array(0);
		for (i = 0; i < this.com.length; i++) {
			if (this.com[i] == 0) { choice[i] = 'ACe'; }
			else if (this.com[i] == 1) { choice[i] = ''; }
			else if (this.com[i] == 2) { choice[i] = 'W߂'; }
			else if (this.com[i] == 3) { choice[i] = '߂'; }
		}
		this.selectionMode.start(this, choice, 25, 26, num);
	} else if (this.location == 'tavernDivide') {
		this.stop = 1, this.selNum2 = 0, this.location = 'tavern';
		if (Party < 0) {
			this.textView.alert(29, 20, 1, 'p[eB[ɒN܂');
		} else {
			this.divide(Party);
			this.textView.alert(29, 20, 1, 'R܂');
		}
	} else if (this.location == 'inn') {
		this.fieldView.viewClear();
		this.textView.titleMessage(38, INN);
		this.pcSel(num, 'inn');
	} else if (this.location == 'inn_1') {
		this.fieldView.viewClear();
		this.textView.titleMessage(38, INN);
		this.textView.partyStatus();
		var pc = this.pcModel[this.partyModel[Party].pc[this.selNum]];
		this.textView.alert(32, 28, 1, 'ႢA' + pc.name + 'Bǂ̕ɔ܂܂H');
		this.textView.messageNonMargin(15, 'center', 'F@' + hzNum(pc.gold, 12) + '@fo');
		var choice = new Array('n@@@@@@@@ij', 'ȈՐQ@@@@@@@@PO@fo^v', 'GRm~[[@@@@TO@fo^v', 'XC[g[@@@@QOO@fo^v', 'CXC[g@@@TOO@fo^v', 'W߂', '߂');
		this.selectionMode.start(this, choice, 25, 'center', num);
	} else if (this.location == 'inn_barn') {
		this.fieldView.viewClear();
		this.textView.titleMessage(38, INN);
		this.textView.partyStatus();
		var pc = this.pcModel[this.partyModel[Party].pc[this.selNum]];
		this.textView.message(35, 28, 'center', pc.name + '͐QĂ܂B', 'left');
		this.stop = 1;
	} else if (this.location == 'inn_bed') {
		this.stop = 1;
		this.week = 0;
		this.innBed();
		return;
	} else if (this.location == 'temple') {
		this.fieldView.viewClear();
		this.textView.titleMessage(38, TEMPLE);
		this.textView.alert(33, 18, 1, 'N̂łH');
		this.textView.textFrameNonMargin(35, this.pcModel.length + 1);
		var y = this.pcModel.length - 1, name, pM = this.pcModel;
		var i, j = 0, tmp = 1;
		this.sortO = new Array(0);
		for (i = 1; i < pM.length; i++) {
			if (pM[i].name == '') { break; }
			if (pM[i].cantMove && pM[i].party == -1) {
				this.sortO[j] = i;
				j++;
			}
		}
		if (this.sortO.length == 0) {
			this.location = 'castleTown';
			if (MusicOn) { musicStart("CASTLETOWN"); }
			save(this.pcModel, this.partyModel);
			this.update(0);
			return;
		}
		for (i = 0; i < this.sortO.length; i++) {
			name = this.pcListNameSet(this.sortO[i]);
			this.textView.write(3, y, name);
			if (pM[this.sortO[i]].state == 3) { tmp = 100; }
			else if (pM[this.sortO[i]].state == 4) { tmp = 200; }
			else if (pM[this.sortO[i]].state == 5) { tmp = 250; }
			else if (pM[this.sortO[i]].state == 6) { tmp = 500; }
			tmp = tmp * pM[this.sortO[i]].level;
			this.textView.write(15, y, hzNum(tmp, 12));
			y--;
		}
		this.textView.textSet('center', 29, 29 - this.pcModel.length);
		this.selectionMode.startNonD(this, this.sortO, 28, 5, 32, num);
		this.textView.partyStatus();
	} else if (this.location == 'temple_1') {
		if (this.selNum < 0) { this.selNum = this.sortO.length - 1; }
		else if (this.selNum >= this.sortO.length) { this.selNum = 0; }
		this.fieldView.viewClear();
		this.textView.titleMessage(38, TEMPLE);
		this.textView.partyStatus();
		this.textView.message(36, 28, 'center', 't̊ź@@@' + hzNum(this.charge, 12) + '@fo\n\nNt[߂܂H', 'left');
		var pM = this.pcModel;
		var i, text = pM[this.sortO[this.selNum]].name + '̏́@';
		for (i = text.length; i < 12; i++) { text += '@'; }
		this.textView.message(16, 28, 'center', text + hzNum(pM[this.sortO[this.selNum]].gold, 12) + '@fo', 'left');
		var y = 5-this.selNum;
		this.textView.textNonFrame(1,6);
		this.textView.write(0,y,'');
		this.textView.textSet(4,6,1);
	} else if (this.location == 'shop') {
		this.fieldView.viewClear();
		this.textView.titleMessage(38, SHOP);
		this.pcSel(num, 'shop');
	} else if (this.location == 'shopIn') {
		this.fieldView.viewClear();
		this.textView.titleMessage(38, SHOP);
		this.shopPc();
		var choice = new Array('', '', '􂢂', 'Ӓ', 'W߂', '߂');
		this.selectionMode.start(this, choice, 26, 9, num);
	} else if (this.location == 'shopIn_1') {
		this.shopPc();
		var pc = this.pcModel[this.pcNum];
		var choice;
		if (pc.action[0] == 0) {
			if (pc.action[1] <= -1) {
				choice = new Array('', 'Z', '', '', '', '̑', '߂');
				this.selectionMode.start(this, choice, 24, 16, num);
			} else { this.shopMenuView(); }
		} else if (pc.action[0] <= 3) {
			if (pc.action[1] == -1 && pc.item[0] > 0) {
				this.shopPcItem(1, num);
			} else if (pc.action[1] >= 0) { this.shopItem(num); }
			else {
				this.location = 'shopIn';
				num = pc.action[0];
				pc.action[0] = -1, pc.action[1] = -1;
				this.update(num);
				return;
			}
		}
	} else if (this.location == 'shopIn_2') {
		var pc = this.pcModel[this.pcNum];
		if (pc.action[0] == 0) {
			this.textView.message(28, 26, 'center', 'Ȃɂ͎gȂ̂łA܂H\n\n@͂\n@@', 'center');
			var choice = new Array(1,1);
			this.selectionMode.startNon(this, choice, 23, 19, num);
		}
	} else if (this.location == 'castle') {
		this.fieldView.viewClear();
		this.textView.titleMessage(38, CASTLE);
		this.textView.partyStatus();
		var party = this.partyModel[Party];
		var clearItem = party.itemHaveCheck(1001);
		var text;
		if (party.titleCheck() > 0) {
			if (MusicOn) { musicStart("CASTLE"); }
			text = 'q͖`҂̊oĂ炵A\n`҂͂܉ɒʂA\nĉy̌F^[̑OւƈēꂽB\n\ngǂACłĂ邩H\niӂ悤ɂȁh';
		} else if (clearItem >= 0) {
			if (MusicOn) { musicStart("ENDING"); }
			this.location = 'gameClear';
			var pc2 = this.pcModel[party.pc[clearItem]];
			var i, item;
			for (i = 0; i < pc2.item.length; i++) {
				item = pc2.item[i];
				if (item >= 10000) { item -= 10000; }
				if (item == 1001) {
					pc2.deleteItem(i);
					break;
				}
			}
			for (i = 0; i < party.pc.length; i++) {
				if (party.pc[i] == 0) { break; }
				pc2 = this.pcModel[party.pc[i]];
				pc2.gold += 50000, pc2.exp += 50000;
				pc2.title = 1;
				pc2.check();
			}
			text = '߂|`ƁA\n`҂͉q̈lɂďɒʂꂽB\nŁA{t̖@gɂĊmFȂA\n΂炭҂ꂽɁA`҂́A\nẙԂւƒʂꂽB\nẙԂł͌F^[Xɏo}ĂA\n`҂ll̎ČB\n\ngC]f̏͊mɖ{łB\nSB{ɂJB\nA܂̐̂\n̑喂@gC]fłƂ́ccB\nȂiɂč̐Ɏp͓̂䂾A\n̉𖾂͉䂪@gɔCƂ悤B\n΂炭̂Ƃ͓ɗނh\n\ngƂÂ悤ȗDGȖ`҂ĂƂ͐SB\n]̂߂ɗ݂͂ė~h';
		} else {
			if (MusicOn) { musicStart("CASTLE"); }
			text = 'q̎̉ɂ́A\n̂悤ȗĎDĂĂB\n\n@n{ɐg߂鑯𐬔sA@\n@@@DԂ҂ɂ́A@@@\n@@@@_ƖJ^B@@@@\n@@@@@@@@@@@@@@@@@@\n@@sN^jAF^[t@@@\n\nĎD̑Oł́Aʎs`҂炵lXA\n̐̂ɂāA\nn{ɂāA\nn{ɏo閂ɂāA\n􂵂Ă`҂ɂĂȂǂA\nЂЂƘbĂB';
		}
		this.textView.message(36, 36, 'center', text, 'center');
	}

	this.fieldView.update();
}

// E
TownMode.prototype.rightEnter = function(num) {

	if (this.location == 'trainingCreate_1') {
		this.nameCheckView(num);
		return;
	} else if (this.location == 'trainingCreate_4' && this.bonus > 0) {
		if (num == 0 && this.abi[0] < ABILITY[this.race][0] + 10) {
			this.abi[0]++, this.bonus--;
		} else if (num == 1 && this.abi[1] < ABILITY[this.race][1] + 10) {
			this.abi[1]++, this.bonus--;
		} else if (num == 2 && this.abi[2] < ABILITY[this.race][2] + 10) {
			this.abi[2]++, this.bonus--;
		} else if (num == 3 && this.abi[3] < ABILITY[this.race][3] + 10) {
			this.abi[3]++, this.bonus--;
		} else if (num == 4 && this.abi[4] < ABILITY[this.race][4] + 10) {
			this.abi[4]++, this.bonus--;
		} else if (num == 5 && this.abi[5] < ABILITY[this.race][5] + 10) {
			this.abi[5]++, this.bonus--;
		}
	} else if (this.location == 'tavernAdd' || this.location == 'temple' || this.location == 'trainingInspect' || this.location == 'trainingDelete' || this.location == 'trainingChangeName' || this.location == 'trainingChangeClass' || this.location == 'trainingSort' || this.location == 'restart') {
		num += 6;
		if (num >= this.sortO.length) { num = this.sortO.length-1; }
		if (this.sortO[num] == 0) {
			for (var i = this.sortO.length-1; i >= 0; i--) {
				if (this.sortO[i] > 0) {
					num = i;
					break;
				}
			}
		}
	} else if (this.location == 'tavernInspect_1') {
		this.pcNum++;
		if (this.pcNum >= this.sortO.length) { this.pcNum = 0; }
		num = 0;
	}

	this.update(num);
}

// 
TownMode.prototype.leftEnter = function(num) {

	if (this.location == 'trainingCreate_1') {
		this.nameCheckView(num);
		return;
	} else if (this.location == 'trainingCreate_4') {
		if (num == 0 && this.abi[0] > ABILITY[this.race][0]) {
			this.abi[0]--, this.bonus++;
		} else if (num == 1 && this.abi[1] > ABILITY[this.race][1]) {
			this.abi[1]--, this.bonus++;
		} else if (num == 2 && this.abi[2] > ABILITY[this.race][2]) {
			this.abi[2]--, this.bonus++;
		} else if (num == 3 && this.abi[3] > ABILITY[this.race][3]) {
			this.abi[3]--, this.bonus++;
		} else if (num == 4 && this.abi[4] > ABILITY[this.race][4]) {
			this.abi[4]--, this.bonus++;
		} else if (num == 5 && this.abi[5] > ABILITY[this.race][5]) {
			this.abi[5]--, this.bonus++;
		}
	} else if (this.location == 'tavernAdd' || this.location == 'temple' || this.location == 'trainingInspect' || this.location == 'trainingDelete' || this.location == 'trainingChangeName' || this.location == 'trainingChangeClass' || this.location == 'trainingSort' || this.location == 'restart') {
		num -= 6;
		if (num < 0) { num = 0; }
		if (this.sortO[num] == 0) {
			for (var i = this.sortO.length-1; i >= 0; i--) {
				if (this.sortO[i] > 0) {
					num = i;
					break;
				}
			}
		}
	} else if (this.location == 'tavernInspect_1') {
		this.pcNum--;
		if (this.pcNum < 0) { this.pcNum = this.sortO.length - 1; }
		num = 0;
	}

	this.update(num);
}

// 
TownMode.prototype.enter = function(num) {
	if (this.location == 'castleTown') {
		if (num == 0) {
			this.location = 'tavern';
			if (MusicOn) { musicStart("TAVERN"); }
			save(this.pcModel, this.partyModel);
		} else if (num == 1) {
			if (Party >= 0) {
				this.location = 'inn';
				if (MusicOn) { musicStart("INN"); }
				save(this.pcModel, this.partyModel);
			} else {
				this.textView.alert(29, 20, 1, 'p[eB[ɒN܂');
				this.stop = 1;
				this.selNum2 = 0;
				this.fieldView.update();
				return;
			}
		} else if (num == 2) {
			if (Party >= 0) {
				this.location = 'shop';
				if (MusicOn) { musicStart("SHOP"); }
				save(this.pcModel, this.partyModel);
			} else {
				this.textView.alert(29, 20, 1, 'p[eB[ɒN܂');
				this.stop = 1;
				this.selNum2 = 0;
				this.fieldView.update();
				return;
			}
		} else if (num == 3) {
			if (Party >= 0) {
				var i, j = 0, tmp = 1, pM = this.pcModel;
				this.sortO = new Array(0);
				for (i = 1; i < pM.length; i++) {
					if (pM[i].name == '') { break; }
					if (pM[i].cantMove && pM[i].party == -1) {
						this.sortO[j] = i;
						j++;
					}
				}
				if (MusicOn) { musicStart("TEMPLE"); }
				save(this.pcModel, this.partyModel);
				if (this.sortO.length > 0) {
					this.location = 'temple';
				} else {
					this.stop = 1;
					var text;
					this.location = 'templeBefore';
					this.fieldView.viewClear();
					this.textView.titleMessage(38, TEMPLE);
					this.textView.partyStatus();
					text = '@̂ṕAٗlȐÂɕ܂ĂB\nȐ̔`ɊJꂽA\nq`҂̎̂^эގpA\n񂾕\̐l̖`҂̎pB';
					this.textView.message(36, 36, 'center', text, 'center');
					this.fieldView.update();
					return;
				}
			} else {
				this.textView.alert(29, 20, 1, 'p[eB[ɒN܂');
				this.stop = 1;
				this.selNum2 = 0;
				this.fieldView.update();
				return;
			}
		} else if (num == 4) {
			this.stop = 1;
			if (Party >= 0) {
				this.location = 'castle';
				save(this.pcModel, this.partyModel);
			} else {
				this.textView.alert(29, 20, 1, 'p[eB[ɒN܂');
				this.selNum2 = 0;
				this.fieldView.update();
				return;
			}
		} else if (num == 5) {
			this.location = 'edgeOfTown';
			if (MusicOn) { musicStart("EDGEofTOWN"); }
		}
		num = 0;
	} else if (this.location == 'edgeOfTown') {
		this.selNum = num;
		if (num == 0) { this.location = 'maze'; }
		else if (num == 1) {
			this.location = 'restart';
			this.sortO = new Array(0);
			var j = 0, pc = this.pcModel;
			for (var i = 1; i < pc.length; i++) {
				if (pc[i].party >= 0 && pc[i].party != Party) {
					if (!pc[i].cantMove) {
						this.sortO[j] = i;
						j++;
					}
				}
			}
			num = 0;
		} else if (num == 2) {
			if (Party >= 0) {
				var party = this.partyModel;
				for (var i = party[Party].pc.length-1; i >= 0; i--) {
					if (party[Party].pc[i] > 0) {
						party[Party].pcDelete(party[Party].pc[i]);
					}
				}
				Party = -1;
			}
			this.location = 'training';
			save(this.pcModel, this.partyModel);
		}
		else if (num == 3) {
			this.location = 'pass';
		}
		else if (num == 4) {
			this.location = 'castleTown';
			if (MusicOn) { musicStart("CASTLETOWN"); }
		}
		num = 0;
	} else if (this.location == 'restart') {
		if (Party >= 0) {
			var party = this.partyModel;
			for (var i = party[Party].pc.length-1; i >= 0; i--) {
				if (party[Party].pc[i] > 0) {
					party[Party].pcDelete(party[Party].pc[i]);
				}
			}
			Party = -1;
		}
		Party = this.pcModel[this.sortO[num]].party;
		this.partyModel[Party].direction = 'north';
		this.dungeonMode.start();
		return;
	} else if (this.location == 'training') {
		this.selNum = num;
		this.selNum2 = -1;
		if (num == 0) { this.location = 'trainingCreate'; }
		else if (num == 1) { this.location = 'trainingInspect'; }
		else if (num == 2) { this.location = 'trainingDelete'; }
		else if (num == 3) { this.location = 'trainingChangeName'; }
		else if (num == 4) { this.location = 'trainingChangeClass'; }
		else if (num == 5) {
			this.location = 'trainingSort';
			var tmp = 0;
			for (var i = 1; i < this.pcModel.length; i++) {
				if (this.pcModel[i].name != '') { tmp++; }
			}
			if (tmp != 0) {
				this.sortO = new Array(tmp);
				this.sortC = new Array(tmp);
				for (var i = 0; i < tmp; i++) {
					this.sortO[i] = i + 1;
					this.sortC[i] = 0;
				}
			}
		}
		else if (num == 6) {
			save(this.pcModel, this.partyModel);
			this.location = 'edgeOfTown';
		}
		num = 0;
	} else if (this.location == 'trainingCreate_1') {
		if (num == 0) { this.location = 'trainingCreate_2'; }
		else if (num == 1) { this.location = 'trainingCreate'; }
		num = 0;
	} else if (this.location == 'trainingCreate_2') {
		this.selNum2 = num;
		this.race = num;
		this.location = 'trainingCreate_3';
		num = 0;
	} else if (this.location == 'trainingCreate_3') {
		this.alignment = num;
		this.location = 'trainingCreate_4';
		this.gFlag = 1;
		num = 0;
	} else if (this.location == 'trainingCreate_4' && this.bonus == 0 && this.cFlag) {
		this.location = 'trainingCreate_5';
		num = 0;
	} else if (this.location == 'trainingCreate_5') {
		this.pcClass = num;
		this.location = 'trainingCreate_6';
		num = 0;
	} else if (this.location == 'trainingCreate_6') {
		if (num == 0) {
			this.pcEnter();
		}
		this.location = 'training';
		if (this.selNum >= 0) { num = this.selNum, this.selNum = -1; }
	} else if (this.location == 'trainingInspect') {
		this.selNum2 = num;
		this.location = 'trainingInspect_1';
		var i, tmp = 0;
		for (i = 1; i < this.pcModel.length; i++) {
			if (this.pcModel[i].name != '') { tmp++; }
			else { break; }
		}
		this.sortO = new Array(tmp);
		for (i = 1; i < this.pcModel.length; i++) {
			if (this.pcModel[i].name != '') {
				this.sortO[i-1] = i;
			} else { break; }
		}
	} else if (this.location == 'trainingDelete') {
		this.selNum2 = num;
		this.location = 'trainingDelete_1';
	} else if (this.location == 'trainingDelete_1') {
		if (num == 0) {
			this.pcDelete(this.selNum2 + 1);
			if (this.pcModel[1].name == '') {
				this.location = 'training';
				num = this.selNum, this.selNum = -1;
			} else {
				this.location = 'trainingDelete';
				num = this.selNum2, this.selNum2 = -1;
				if (this.pcModel[num + 1].name == '') {
					num--;
					if (num < 0) { num = 0; }
				}
			}
		} else if (num == 1) {
			this.location = 'trainingDelete';
			if (this.selNum2 >= 0) { num = this.selNum2, this.selNum2 = -1; }
		}
	} else if (this.location == 'trainingDelete_2') {
		if (num == 0) {
			allDataClear();
			gameMode.init(true);
			return;
		} else if (num == 1) {
			this.location = 'training';
			if (this.selNum >= 0) { num = this.selNum, this.selNum = -1; }
		}
	} else if (this.location == 'trainingChangeName') {
		this.selNum2 = num;
		this.location = 'trainingChangeName_1';
	} else if (this.location == 'trainingChangeClass') {
		this.selNum2 = num;
		num = 0;
		this.location = 'trainingChangeClass_1';
	} else if (this.location == 'trainingChangeClass_1') {
		this.pcClass = num;
		num = 0;
		this.location = 'trainingChangeClass_2';
	} else if (this.location == 'trainingChangeClass_2') {
		if (num == 0) {
			var pc = this.pcModel[this.selNum2+1];
			pc.pcClass = this.pcClass;
			var i;
			for (i = 0; i < pc.abi.length; i++) {
				pc.abi[i] = ABILITY[pc.race][i];
			}
			pc.level = 1, pc.exp = 0;
			pc.ageWeek += 100 + dice(1,100);
			var item, data;
			for (i = 0; i < pc.item.length; i++) {
				if (pc.item[i] == 0) { break; }
				if (pc.itemS[i]) {
					item = itemData(pc.item[i]);
					data = NtoP(item[3]);
					if(!data[pc.pcClass]) {
						pc.itemS[i] = 0;
					}
				}
			}
			for (i = 0; i < 7; i++) {
				pc.mpMMax[i] = 0;
				pc.mpPMax[i] = 0;
			}
			pc.levelUpSpell();
			for (i = 0; i < pc.mpM.length; i++) {
				pc.mpM[i] = pc.mpMMax[i];
				pc.mpP[i] = pc.mpPMax[i];
			}
			pc.check();
			this.location = 'trainingChangeClass';
			num = this.selNum2;
		} else if (num == 1) {
			this.location = 'trainingChangeClass';
			num = this.selNum2;
		}
	} else if (this.location == 'trainingSort') {
		this.pcSort(num);
		if (this.sortO[num] == 0) {
			num--;
			if (num < 0) { num = 0; }
		}
		if (this.sortO[0] == 0) {
			this.pcSortSet();
			this.location = 'training';
			if (this.selNum >= 0) {
				num = this.selNum, this.selNum = -1;
			}
		}
	} else if (this.location == 'pass') {
		if (num == 0) {
			this.location = 'passView';
		} else if (num == 1) {
			this.location = 'passInput';
		}
	} else if (this.location == 'tavern') {
		if (num == 0) {
			this.location = 'tavernAdd';
			this.pcAddListCreate();
			num = 0;
		} else if (num == 1) {
			this.location = 'tavernDelete';
			num = 0;
		} else if (num == 2) {
			this.location = 'tavernInspect';
			num = 0;
		} else if (num == 3) {
			this.location = 'tavernDivide';
		} else if (num == 4) {
			save(this.pcModel, this.partyModel);
			this.location = 'castleTown';
			if (MusicOn) { musicStart("CASTLETOWN"); }
			num = 0;
		}
	} else if (this.location == 'tavernAdd') {
		if (Party < 0) {
			for (i = 0; i < this.partyModel.length; i++) {
				if (this.partyModel[i].pc[0] == 0) {
					Party = i;
					break;
				}
			}
			this.partyModel[Party].init();
		}
		this.partyModel[Party].pcAdd(this.sortO[num]);
		this.pcAddListCreate();
		if (this.sortO.length == 0) {
			this.location = 'tavern';
			num = 0;
		} else if (Party >= 0) {
			if (this.partyModel[Party].pc[5] > 0) {
				this.location = 'tavern';
				num = 0;
			}
		}
	} else if (this.location == 'tavernDelete') {
		this.partyModel[Party].pcDelete(this.partyModel[Party].pc[num]);
		if (this.partyModel[Party].pc[0] == 0) {
			Party = -1;
			this.location = 'tavern';
			num = 1;
		}
	} else if (this.location == 'tavernInspect') {
		this.pcNum = num;
		this.location = 'tavernInspect_1';
		num = 0;
	} else if (this.location == 'tavernInspect_1') {
		if (this.com[num] == 0) {
			this.itemMode.start('town', this.sortO[this.pcNum]);
			return;
		} else if (this.com[num] == 1) {
			this.itemMode.equipmentStart('town', this.sortO[this.pcNum]);
			return;
		} else if (this.com[num] == 2) {
			var gold = 0, pc = this.partyModel[Party].pc;
			for (var i = 0; i < pc.length; i++) {
				if (pc[i] > 0) {
					gold += this.pcModel[pc[i]].gold;
					this.pcModel[pc[i]].gold = 0;
				}
			}
			if (gold > 999999999999) { gold = 999999999999; }
			this.pcModel[this.sortO[this.pcNum]].gold = gold;
		} else if (this.com[num] == 3) {
			this.location = 'tavernInspect';
			num = this.pcNum + 1;
			if (this.sortO.length <= num) { num = 0; }
			this.fieldView.viewClear();
			this.textView.titleMessage(38, TAVERN);
			this.textView.partyStatus();
		}
	} else if (this.location == 'inn') {
		this.selNum = num;
		if (this.pcModel[this.sortO[this.selNum]].cantMove) {
			num = this.selNum + 1;
			if (num > 5) { num = 0; }
			else if (this.partyModel[Party].pc[num] == 0) {
				num = 0;
			}
		} else {
			this.location = 'inn_1';
			num = 0;
		}
	} else if (this.location == 'inn_1') {
		var pc = this.pcModel[this.sortO[this.selNum]];
		if (num == 0) {
			if (pc.state == 1) { pc.state = 0; }
			this.selNum2 = 0;
			this.location = 'inn_barn';
			if (dice(1, 70) <= 10) { pc.ageWeek++; }
		} else if (num == 1) {
			if (pc.state == 1) { pc.state = 0; }
			this.selNum2 = 1;
			if (pc.gold < 10 || pc.hp == pc.hpMax) {
				this.location = 'inn_barn';
				if (dice(1, 70) <= 10) { pc.ageWeek++; }
			} else {
				this.location = 'inn_bed';
				this.hpPlus = 1;
				this.charge = 10;
			}
		} else if (num == 2) {
			if (pc.state == 1) { pc.state = 0; }
			this.selNum2 = 2;
			if (pc.gold < 50 || pc.hp == pc.hpMax) {
				this.location = 'inn_barn';
				if (dice(1, 70) <= 10) { pc.ageWeek++; }
			} else {
				this.location = 'inn_bed';
				this.hpPlus = 3;
				this.charge = 50;
			}
		} else if (num == 3) {
			if (pc.state == 1) { pc.state = 0; }
			this.selNum2 = 3;
			if (pc.gold < 200 || pc.hp == pc.hpMax) {
				this.location = 'inn_barn';
				if (dice(1, 70) <= 10) { pc.ageWeek++; }
			} else {
				this.location = 'inn_bed';
				this.hpPlus = 7;
				this.charge = 200;
			}
		} else if (num == 4) {
			if (pc.state == 1) { pc.state = 0; }
			this.selNum2 = 4;
			if (pc.gold < 500 || pc.hp == pc.hpMax) {
				this.location = 'inn_barn';
				if (dice(1, 70) <= 10) { pc.ageWeek++; }
			} else {
				this.location = 'inn_bed';
				this.hpPlus = 10;
				this.charge = 500;
			}
		} else if (num == 5) {
			var gold = 0, ppc = this.partyModel[Party].pc;
			for (var i = 0; i < ppc.length; i++) {
				if (ppc[i] > 0) {
					gold += this.pcModel[ppc[i]].gold;
					this.pcModel[ppc[i]].gold = 0;
				}
			}
			pc.gold = gold;
		} else if (num == 6) {
			this.location = 'inn';
			num = this.selNum + 1;
			if (num > 5) { num = 0; }
			else if (this.partyModel[Party].pc[num] == 0) {
				num = 0;
			}
		}
	} else if (this.location == 'temple') {
		this.location = 'temple_1';
		this.pcNum = this.sortO[num];
		var tmp, pM = this.pcModel;
		if (pM[this.pcNum].state == 3) { tmp = 100; }
		else if (pM[this.pcNum].state == 4) { tmp = 200; }
		else if (pM[this.pcNum].state == 5) { tmp = 250; }
		else if (pM[this.pcNum].state == 6) { tmp = 500; }
		this.charge = tmp * pM[this.pcNum].level;
		this.sortO = new Array(0);
		var i, party = this.partyModel[Party];
		for (i = 0; i < party.pc.length; i++) {
			if (pM[party.pc[i]].name == '') { break; }
			this.sortO[i] = party.pc[i];
		}
		this.selNum = 0;
	} else if (this.location == 'shop') {
		this.selNum = num;
		this.pcNum = this.sortO[this.selNum];
		if (this.pcModel[this.pcNum].cantMove) {
			num = this.selNum + 1;
			if (num > 5) { num = 0; }
			else if (this.partyModel[Party].pc[num] == 0) {
				num = 0;
			}
		} else {
			this.pcModel[this.pcNum].action[0] = -1;
			this.pcModel[this.pcNum].action[1] = -1;
			this.location = 'shopIn';
			num = 0;
		}
	} else if (this.location == 'shopIn') {
		var i, pc = this.pcModel[this.pcNum];
		if (num == 0) {
			this.location = 'shopIn_1';
			pc.action[0] = num;
			if (pc.action[1] < -1) { num = (pc.action[1]+2) * -1; }
			else { num = 0; }
			pc.action[1] = -1;
		} else if (num <= 3) {
			if (pc.item[0] > 0) {
				this.location = 'shopIn_1';
				pc.action[0] = num;
				pc.action[1] = -1;
				num = 0;
			}
		} else if (num == 4) {
			var gold = 0, ppc = this.partyModel[Party].pc;
			for (i = 0; i < ppc.length; i++) {
				if (ppc[i] > 0) {
					gold += this.pcModel[ppc[i]].gold;
					this.pcModel[ppc[i]].gold = 0;
				}
			}
			pc.gold = gold;
		} else if (num == 5) {
			this.location = 'shop';
			num = this.selNum + 1;
			if (num > 5) { num = 0; }
			else if (this.partyModel[Party].pc[num] == 0) {
				num = 0;
			}
		}
	} else if (this.location == 'shopIn_1') {
		var pc = this.pcModel[this.pcNum];
		if (pc.action[0] == 0 && pc.action[1] == -1) {
			if (num <= 5) {
				pc.action[1] = num;
				this.shopMenuSet(num);
				this.selNum2 = 0;
				this.listNum = 0;
			} else if (num == 6) {
				this.location = 'shopIn';
				num = pc.action[0];
				pc.action[0] = -1;
			}
		} else if (pc.action[0] == 1) {
			if (pc.action[1] == -1) {
				pc.action[1] = num;
				num = 0;
			} else if (pc.action[1] >= 0) {
				if (num == 0) {
					var item = itemData(pc.item[pc.action[1]]);
					if (pc.item[pc.action[1]] >= 10000) {
						pc.gold += 1;
					} else {
						pc.gold += Math.floor(item[11] / 2);
					}
					var tmp = pc.item[pc.action[1]]-1;
					if (ItemStock[tmp] < 31) {
						ItemStock[tmp]++;
					}
					pc.deleteItem(pc.action[1]);
					pc.check();
					this.shopPc();
					this.shopPcItem(0, 0);
					this.textView.alert(25, 26, 1, 'Ɍp͂܂񂩁H');
				} else if (num == 1) {
					this.shopPcItem(0, 0);
					this.textView.alert(25, 26, 1, 'NłԈႢ͂܂');
				}
				this.selNum2 = pc.action[1];
				pc.action[1] = -1;
				this.stop = 1;
				this.fieldView.update();
				return;
			}
		} else if (pc.action[0] >= 2) {
			pc.action[1] = num;
			num = 0;
		}
	} else if (this.location == 'shopIn_2') {
		if (num == 0) {
			var pc = this.pcModel[this.pcNum];
			var item = itemData(this.sortO[this.selNum2]);
			var tmp = this.sortO[this.selNum2]-1;
			if (ItemStock[tmp] < 31) { ItemStock[tmp]--; }
			pc.gold -= item[11];
			pc.getItem(this.sortO[this.selNum2]);
			this.shopPc();
			this.shopMenuView();
			if (ItemStock[tmp] == 0) {
				text = '͍Ō̈ł';
			} else {
				text = 'ƂCɏ܂';
			}
			this.textView.alert(25, 26, 1, text);
			this.location = 'shopIn_1';
			this.stop = 1;
			this.fieldView.update();
			return;
		} else if (num == 1) {
			this.location = 'shopIn_1';
		}
	}

	this.update(num);
}

// LZ
TownMode.prototype.cancel = function(num) {

	if (this.location == 'castleTown') {
		this.location = 'edgeOfTown';
		if (MusicOn) { musicStart("EDGEofTOWN"); }
		num = 0;
	} else if (this.location == 'edgeOfTown') {
		this.location = 'castleTown';
		if (MusicOn) { musicStart("CASTLETOWN"); }
		num = 0;
	} else if (this.location == 'restart') {
		this.location = 'edgeOfTown';
		num = 0;
	} else if (this.location == 'training') {
		save(this.pcModel, this.partyModel);
		this.location = 'edgeOfTown';
		num = 0;
	} else if (this.location == 'trainingCreate_1') {
		this.location = 'trainingCreate';
		num = 0;
	} else if (this.location == 'trainingCreate_2') {
		this.location = 'trainingCreate';
		num = 0;
	} else if (this.location == 'trainingCreate_3') {
		this.location = 'trainingCreate_2';
		this.race = -1;
		num = this.selNum2, this.selNum2 = -1;
	} else if (this.location == 'trainingCreate_4') {
		this.gFlag = 1;
		num = 0;
	} else if (this.location == 'trainingCreate_5') {
		this.location = 'trainingCreate_4';
		num = 0;
	} else if (this.location == 'trainingCreate_6') {
		this.location = 'training';
		if (this.selNum >= 0) { num = this.selNum, this.selNum = -1; }
	} else if (this.location == 'trainingInspect') {
		this.location = 'training';
		if (this.selNum >= 0) { num = this.selNum, this.selNum = -1; }
	} else if (this.location == 'trainingDelete') {
		this.location = 'training';
		if (this.selNum >= 0) { num = this.selNum, this.selNum = -1; }
	} else if (this.location == 'trainingDelete_1') {
		this.location = 'trainingDelete';
		if (this.selNum2 >= 0) { num = this.selNum2, this.selNum2 = -1; }
	} else if (this.location == 'trainingDelete_2') {
		this.location = 'training';
		if (this.selNum >= 0) { num = this.selNum, this.selNum = -1; }
	} else if (this.location == 'trainingChangeName') {
		this.location = 'training';
		if (this.selNum >= 0) { num = this.selNum, this.selNum = -1; }
	} else if (this.location == 'trainingChangeClass') {
		this.location = 'training';
		if (this.selNum >= 0) { num = this.selNum, this.selNum = -1; }
	} else if (this.location == 'trainingChangeClass_1' || this.location == 'trainingChangeClass_2') {
		this.location = 'trainingChangeClass';
		num = this.selNum2;
	} else if (this.location == 'trainingSort') {
		if (this.sortC[0] == 0) {
			this.location = 'training';
			if (this.selNum >= 0) {
				num = this.selNum, this.selNum = -1;
			}
		} else { this.pcSortCancel(); }
	} else if (this.location == 'pass') {
		this.location = 'edgeOfTown';
		num = 0;
	} else if (this.location == 'tavern' || this.location == 'inn' || this.location == 'temple' || this.location == 'shop') {
		save(this.pcModel, this.partyModel);
		this.location = 'castleTown';
		if (MusicOn) { musicStart("CASTLETOWN"); }
		num = 0;
	} else if (this.location == 'tavernAdd') {
		this.location = 'tavern';
		num = 0;
	} else if (this.location == 'tavernDelete') {
		this.location = 'tavern';
		num = 1;
	} else if (this.location == 'tavernInspect') {
		this.location = 'tavern';
		num = 2;
	} else if (this.location == 'tavernInspect_1') {
		this.location = 'tavernInspect';
		num = this.pcNum + 1;
		if (this.sortO.length <= num) { num = 0; }
		this.fieldView.viewClear();
		this.textView.titleMessage(38, TAVERN);
		this.textView.partyStatus();
	} else if (this.location == 'inn_1') {
		this.location = 'inn';
		num = this.selNum + 1;
		if (num > 5) { num = 0; }
		else if (this.partyModel[Party].pc[num] == 0) { num = 0; }
	} else if (this.location == 'shopIn') {
		this.location = 'shop';
		num = this.selNum + 1;
		if (num > 5) { num = 0; }
		else if (this.partyModel[Party].pc[num] == 0) { num = 0; }
	} else if (this.location == 'shopIn_1') {
		var pc = this.pcModel[this.pcNum];
		if (pc.action[0] == 0 && pc.action[1] == -1) {
			this.location = 'shopIn';
			num = pc.action[0];
			pc.action[0] = -1;
		} else if (pc.action[0] >= 1 && pc.action[0] <= 3 && pc.action[1] == -1) {
			this.location = 'shopIn';
			num = pc.action[0];
			pc.action[0] = -1, pc.action[1] = -1;
		} else if (pc.action[0] == 1 && pc.action[0] >= 0) {
			this.shopPcItem(0, 0);
			this.textView.alert(25, 26, 1, 'NłԈႢ͂܂');
			this.selNum2 = pc.action[1];
			pc.action[1] = -1;
			this.stop = 1;
			this.fieldView.update();
			return;
		}
	} else if (this.location == 'shopIn_2') {
		this.location = 'shopIn_1';
	}
	if (num == null) { num = 0; }
	this.update(num);
}

// L[ꂽƂ
TownMode.prototype.onKeyPress = function(key) {

	if (key == 'r' || key == 'R') {
		Reset = 1;
		gameMode.init(true);
		return;
	}
	if (!KeyFlag) { return; }

	var num;
	if (this.stop) {
		if (this.location == 'maze') {
			var party = this.partyModel[Party];
			party.floor = -1, party.x = 0, party.y = 0;
			party.bright = 0, party.protection = 0;
			party.discrimination = 0, party.direction = 'north';
			this.dungeonMode.start();
			return;
		} else if (this.location == 'inn_barn') {
			var dead = this.levelUp(this.partyModel[Party].pc[this.selNum]);
			if (dead) {
				if (this.partyModel[Party].pc[0] == 0) {
					Party = -1;
					this.location = 'castleTown';
					if (MusicOn) { musicStart("CASTLETOWN"); }
					this.selNum2 = 0;
				} else {
					this.location = 'inn';
					this.selNum2 = this.selNum;
				}
			} else { this.location = 'inn_1'; }
			return;
		} else if (this.location == 'inn_bed') {
			var pc = this.pcModel[this.sortO[this.selNum]];
			if (key == '0' || key == 'x' || key == 'X' || pc.hp == pc.hpMax || pc.gold < this.charge) {
				this.location = 'inn_barn';
				this.onKeyPress('none');
			} else { this.innBed(); }
			return;
		} else if (this.location == 'trainingChangeClass_1') {
			this.location = 'trainingChangeClass';
		} else if (this.location == 'passInput') {
			this.location = 'edgeOfTown';
			document.f.t.blur();
			document.f.t.value = '';
			this.selNum = 0;
		} else if (this.location == 'temple_1') {
			if (this.count == 0) {
				this.text += '@@F';
			} else if (this.count == 1) {
				this.text += '@@r';
			} else if (this.count == 2) {
				this.text += '@@OI';
				this.location = 'temple_2';
			}
			this.textView.message(36, 22, 'center', this.text, 'left');
			this.count++;
			this.fieldView.update();
			return;
		} else if (this.location == 'temple_2') {
			var pM = this.pcModel;
			var state = pM[this.pcNum].state;
			var name = pM[this.pcNum].name, text;
			var check = 1;
			if (state == 3 || state == 4) {
				pM[this.pcNum].state = 0;
				pM[this.pcNum].check();
			} else {
				var r = pM[this.pcNum].abi[3] + pM[this.pcNum].abi[5];
				r += 60;
				if (r > 95) { r = 95; }
				if (View) { alert('F' + r + '%'); }
				if (dice(1, 100) <= r) {
					if (state == 5) {
						pM[this.pcNum].ageWeek += 2;
					} else {
						pM[this.pcNum].ageWeek += 4;
					}
					pM[this.pcNum].state = 0;
					pM[this.pcNum].sleep = 0;
					pM[this.pcNum].hpCtrl(9999);
					pM[this.pcNum].check();
				} else {
					if (state == 5) {
						pM[this.pcNum].state = 6;
						check = 2;
					} else {
						pM[this.pcNum].init();
						this.pcDelete(this.pcNum);
						check = 3;
					}
				}
			}
			if (check == 1) {
				text = name + '͌CɂȂ';
			} else if (check == 2) {
				text = 'cOȂh̋V͎s܂\n\n' + name + '͂͂ҍ̋Vs˂΂ȂȂ';
			} else if (check == 3) {
				text = 'cOȂҍ̋V͎s܂\n\n' + name + '͖܂';
			}
			this.textView.message(36, 26, 'center', text, 'center');
			this.fieldView.update();
			this.location = 'temple';
			this.selNum2 = 0;
			return;
		} else if (this.location == 'temple_out' || this.location == 'castle' || this.location == 'templeBefore') {
			if (MusicOn) { musicStart("CASTLETOWN"); }
			this.location = 'castleTown';
			this.selNum2 = 0, this.selNum = 0;
		} else if (this.location == 'gameClear') {
			this.fieldView.viewClear();
			this.textView.titleMessage(38, CASTLE);
			this.textView.partyStatus();
			var text = '@@߂łƂI@@\n\nȂ́uC]f̏v߂A\nF^[^ɑłB\nF^[́AJƂ\nTOCOOOfo@@\nTOCOOOdwo@\n`҂ɗ^ARmƂĎ藧ĂB\n\ngւāAh_Ḿij邪悢Bh';
			this.textView.message(36, 36, 'center', text, 'center');
			this.fieldView.update();
			this.location = 'castle';
			return;
		}

		num = 0;
		if (this.selNum2 >= 0) {
			num = this.selNum2;
		} else if (this.selNum >= 0) {
			num = this.selNum;
		}
		this.stop = 0;
		this.update(num);
		return;
	}

	if (key == '8' || key == 'u' || key == 'U') {
		if (this.location == 'temple_1') {
			this.selNum--;
			this.update(0);
		} else if (this.location == 'shopIn_1') {
			var pc = this.pcModel[this.pcNum];
			if (pc.action[0] == 0) {
				this.selNum2--;
				this.shopMenuView('up');
				this.fieldView.update();
			}
		}
	} else if (key == '4' || key == 'h' || key == 'H') {
		if (this.location == 'trainingInspect_1') {
			this.selNum2--;
			if (this.selNum2 < 0) {
				this.selNum2 = this.sortO.length - 1;
			}
			this.update(this.selNum2);
		} else if (this.location == 'temple_1') {
			this.update(0);
		} else if (this.location == 'shopIn_1') {
			var pc = this.pcModel[this.pcNum];
			if (pc.action[0] == 0) {
				this.selNum2 -= 6;
				this.shopMenuView('left');
				this.fieldView.update();
			}
		}
	} else if (key == '6' || key == 'k' || key == 'K') {
		if (this.location == 'trainingInspect_1') {
			this.selNum2++;
			if (this.selNum2 >= this.sortO.length) {
				this.selNum2 = 0;
			}
			this.update(this.selNum2);
		} else if (this.location == 'temple_1') {
			this.update(0);
		} else if (this.location == 'shopIn_1') {
			var pc = this.pcModel[this.pcNum];
			if (pc.action[0] == 0) {
				this.selNum2 += 6;
				this.shopMenuView('right');
				this.fieldView.update();
			}
		}
	} else if (key == '2' || key == 'n' || key == 'N') {
		if (this.location == 'temple_1') {
			this.selNum++;
			this.update(0);
		} else if (this.location == 'shopIn_1') {
			var pc = this.pcModel[this.pcNum];
			if (pc.action[0] == 0) {
				this.selNum2++;
				this.shopMenuView('down');
				this.fieldView.update();
			}
		}
	} else if (key == '5' || key == 'z' || key == 'Z') {
		if (this.location == 'passInput') {
			this.passCheck();
		} else if (this.location == 'temple_1') {
			var pM = this.pcModel;
			if (!pM[this.sortO[this.selNum]].cantMove) {
				this.fieldView.viewClear();
				this.textView.titleMessage(38, TEMPLE);
				this.textView.partyStatus();
				if (pM[this.sortO[this.selNum]].gold < this.charge) {
					this.textView.message(36, 20, 'center', '̃P`Ȕw҂߁I\n\nočsII', 'center');
					this.location = 'temple_out';
					this.selNum = 0;
				} else {
					pM[this.sortO[this.selNum]].gold -= this.charge;
					this.text = '';
					this.count = 0;
					this.textView.message(36, 22, 'center', this.text, 'left');
				}
				this.stop = 1;
				this.fieldView.update();
			}
		} else if (this.location == 'shopIn_1') {
			var pc = this.pcModel[this.pcNum];
			var text = '';
			if (pc.action[0] == 0) {
				var item = itemData(this.sortO[this.selNum2]);
				if (ItemStock[this.sortO[this.selNum2]-1] == 0) {
					this.textView.alert(25, 26, 1, '؂ł');
					this.stop = 1;
				} else if (pc.gold < item[11]) {
					text = 'Ȃ̏ł͕܂';
				} else if (pc.item[7] > 0) {
					text = 'ȏ͎Ă܂';
				} else {
					var data = NtoP(item[3]);
					if (item[3] > 0 && !data[pc.pcClass]) {
						this.location = 'shopIn_2';
						this.textView.message(28, 26, 'center', 'Ȃɂ͎gȂ̂łA܂H\n\n@͂\n@@', 'center');
						var choice = new Array(1,1);
						this.selectionMode.startNon(this, choice, 23, 19, 0);
					} else {
						var tmp = this.sortO[this.selNum2]-1;
						if (ItemStock[tmp] < 31) {
							ItemStock[tmp]--;
						}
						pc.gold -= item[11];
						pc.getItem(this.sortO[this.selNum2]);
						this.shopPc();
						this.shopMenuView();
						if (ItemStock[tmp] == 0) {
							text = '͍Ō̈ł';
						} else {
							text = 'ƂCɏ܂';
						}
					}
				}
				if (text != '') {
					this.textView.alert(25, 26, 1, text);
					this.stop = 1;
				}
				this.fieldView.update();
			}
		}
	} else if (key == '0' || key == 'x' || key == 'X') {
		if (this.location == 'trainingInspect_1') {
			this.location = 'trainingInspect';
			num = this.selNum2 + 1;
			this.selNum2 = -1;
			if (this.sortO.length <= num) { num = 0; }
			this.update(num);
		} else if (this.location == 'passInput') {
			this.location = 'edgeOfTown';
			document.f.t.blur();
			document.f.t.value = '';
			this.update(0);
		} else if (this.location == 'temple_1') {
			this.location = 'temple';
			this.update(0);
		} else if (this.location == 'shopIn_1') {
			var pc = this.pcModel[this.pcNum];
			if (pc.action[0] == 0) {
				this.location = 'shopIn';
				pc.action[0] = -1;
				var tmp = pc.action[1];
				pc.action[1] = -1;
				this.update(0);
				pc.action[1] = (tmp * -1)-2;
				this.selectionMode.onKeyPress(5);
			}
		} else if (this.location == 'passView') {
			this.location = 'edgeOfTown';
			document.f.t.blur();
			document.f.t.value = '';
			this.update(0);
		}
	}

}

