// Q[Ŝ̐

// 萔
SCENARIO = "Jry#1";

MAP_SIZE_X = 16;
MAP_SIZE_Y = 16;
FLOOR_MAX = 10;
FIELD_SIZE_X = 44;
FIELD_SIZE_Y = 40;

BGM = {};
BGM_LIST = ["TITLE,opening", "CASTLETOWN,castleTown", "EDGEofTOWN,edgeOfTown", "TAVERN,tavern", "INN,inn", "SHOP,shop", "TEMPLE,temple", "CASTLE,castle", "DUNGEON,dungeon", "CAMP,camp", "BATTLE,battle", "BOSS,boss", "ENDING,ending", "ANNIHILATE,annihilate"];
SE = {};
SE_LIST = ["WALL,wall", "KICKDOOR,kickdoor", "LEVELUP,levelup", "BATTLESTART,battleStart", "BATTLEWIN,battleWin", "ATTACK,attack", "ATTACKHIT,hit", "CRITICAL,critical", "SPELLRECITE,spell", "SPELLWARP,spell", "ARROW,arrow", "BOMB,bomb", "STUN,stun", "ALARM,alarm"];

SUBTITLE = 'oqnuhmf@fqntmcr\nne\nsgd@knqc@ne@rvnqc@l`rsdq';

TAVERN = 'hrgk`mdfr@s`udqm';
INN = '`cudmstqdqfr@hmm';
SHOP = 'c`qetmjfr@sq`chmf@onrs';
TEMPLE = 'sdlokd@ne@lnqftd';
CASTLE = 'kdbs`mh`@b`rskd';


MAGE_SPELL = new Array(7);
MAGE_SPELL[0] = new Array('΋', 'U', '');
MAGE_SPELL[1] = new Array('', '', 'T');
MAGE_SPELL[2] = new Array('削', '', 'ŋ');
MAGE_SPELL[3] = new Array('', '', '');
MAGE_SPELL[4] = new Array('v', '', 'Ŗ');
MAGE_SPELL[5] = new Array('X', '', '');
MAGE_SPELL[6] = new Array('', ']', 'ψ');

PRIEST_SPELL = new Array(7);
PRIEST_SPELL[0] = new Array('', '', 'j');
PRIEST_SPELL[1] = new Array('Î', '', '');
PRIEST_SPELL[2] = new Array('', '_', '');
PRIEST_SPELL[3] = new Array('', '', 'F');
PRIEST_SPELL[4] = new Array('', '', 'n');
PRIEST_SPELL[5] = new Array('', '', 'A');
PRIEST_SPELL[6] = new Array('b', '_', 'ҍ');

ABILITY = new Array(5);
ABILITY[0] = new Array(8,8,8,8,8,8);
ABILITY[1] = new Array(7,10,10,6,9,6);
ABILITY[2] = new Array(10,7,10,10,5,6);
ABILITY[3] = new Array(7,7,10,8,10,7);
ABILITY[4] = new Array(5,7,7,6,12,15);

LU_EXP = new Array(8);
LU_EXP[0] = new Array(1000,724,1248,2152,3710,6397,11029,19015,32785,56526,97458,168031,289709);
LU_EXP[1] = new Array(1100,796,1372,2366,4079,7033,12126,20907,36046,62149,107153,184747,318529);
LU_EXP[2] = new Array(1050,760,1310,2259,3895,6715,11578,19962,34417,59343,102307,176397,304132);
LU_EXP[3] = new Array(900,651,1123,1936,3338,5755,9922,17107,29495,50854,87679,151171,260639);
LU_EXP[4] = new Array(1200,905,1587,2785,4886,8572,15038,26383,46286,81203,142462,249933,438479);
LU_EXP[5] = new Array(1250,942,1653,2900,5088,8926,15660,27473,48199,84559,148350,260263,456601);
LU_EXP[6] = new Array(1300,980,1720,3017,5293,9286,16291,28581,50142,87968,154330,270755,475008);
LU_EXP[7] = new Array(1450,1093,1918,3368,5900,10356,18169,31875,55921,98107,172118,301961,529757);

// O[oϐ
SeSet = 0;
Reset = 0;
View = 0; /* foOp */

// Q[[hNX
function GameMode() {
	var i, j, k;

	MapCheck = new Array();
	for (var k = 0; k < FLOOR_MAX; k++) {
		MapCheck[k] = new Array(MAP_SIZE_X * MAP_SIZE_Y);
		for (var i = 0; i < MAP_SIZE_X; i++) {
			for (var j = 0; j < MAP_SIZE_Y; j++) {
				MapCheck[k][i + j * MAP_SIZE_X] = 0;
			}
		}
	}
	i = 1;
	while (true) {
		j = itemData(i);
		if (j[0] == 0 || i >= 1000) {
			i--;
			break;
		} else { i++; }
	}
	ItemStock = new Array(i);
	for (i = 0; i < ItemStock.length; i++) {
		if ((i >= 0 && i <= 13) || i == 15 || i == 16 || i == 17 || i == 24 || i == 25 || i == 27 || i == 28 || i == 30 || i == 35 || i == 56) {
			ItemStock[i] = 31;
		} else if (i == 18 || i == 23 || i == 26 || i == 29 || i == 43 || i == 45) {
			ItemStock[i] = 1;
		} else if (i == 14 || i == 20 || i == 33 || i == 42 || i == 44 || i == 46 || i == 57) {
			ItemStock[i] = 2;
		} else if (i == 31 || i == 47) {
			ItemStock[i] = 15;
		} else { ItemStock[i] = 0; }
	}

	// f̍\z
	this.dungeonModel = new DungeonModel(MAP_SIZE_X, MAP_SIZE_Y, FIELD_SIZE_X, FIELD_SIZE_Y);
	this.pcModel = new Array(19);
	for (i = 0; i < this.pcModel.length; i++) {
		this.pcModel[i] = new PcModel(i);
	}
	this.partyModel = new Array(18);
	for (i = 0; i < this.partyModel.length; i++) {
		this.partyModel[i] = new PartyModel(i, this.partyModel, this.pcModel);
	}
	this.npcModel = new Array();
	for (i = 0; i < 4; i++) {
		for (j = 0; j < 9; j++) {
			this.npcModel[i + j * 4] = new NpcModel();
		}
	}

	// r[̍\z
	this.fieldView = new FieldView(FIELD_SIZE_X, FIELD_SIZE_Y, this.dungeonModel);
	this.textView = new TextView(FIELD_SIZE_X, FIELD_SIZE_Y, this.fieldView, this.partyModel, this.pcModel);

	// Tu[hIuWFNg̍\z
	this.selectionMode = new SelectionMode(this.fieldView, this.textView, this.pcModel);
	this.itemMode = new ItemMode(this.fieldView, this.textView, this.pcModel, this.partyModel, this.selectionMode);
	this.dungeonMode = new DungeonMode(this.dungeonModel, this.partyModel, this.pcModel, this.fieldView, this.textView, this.selectionMode, this.itemMode);
	this.townMode = new TownMode(this.pcModel, this.partyModel, this.fieldView, this.textView, this.selectionMode, this.dungeonMode, this.itemMode);
	this.battleMode = new BattleMode(this.pcModel, this.partyModel, this.npcModel, this.fieldView, this.textView, this.selectionMode, this.dungeonMode, this.itemMode);

	this.init();
}

// Q[̏
GameMode.prototype.init = function(reset) {
	var i, j;
	document.f.t.value = '';
	this.mode = 'title';

	// O[oϐ
	KeyFlag = 1;
	MusicOn = 0;
	SeOn = 0;
	MapOn = 1;
	Ie = 0;
	Party = -1;

	let ua = navigator.userAgent.toLowerCase();
	if (ua.indexOf("msie") > -1 || ua.indexOf("trident") > -1) { Ie = 1; }

	if(!load(this.pcModel, this.partyModel)) {
		this.formatSet();
	}

	//L[͂̏
	KeyManager_init();
	KeyManager_addListener(this);

	var party = this.partyModel;
	for (i = 0; i < party.length; i++) {
		if (party[i].floor == 0 && party[i].pc[0] > 0) {
			if (Reset) { Party = i; }
			else {
				for (j = party[i].pc.length-1; j >= 0; j--) {
					if (party[i].pc[j] > 0) {
						party[i].pcDelete(party[i].pc[j]);
					}
				}
			}
			break;
		}
	}
	if (Reset) { Reset = 0; }

	this.selected = 0;
	musicStop();
	if (reset) {
		if (MusicOn) { musicStart("TITLE"); }
		this.titleUpdate();
	} else {
		this.loadingType = "music";
		this.loadingNum = -1;
		this.fileLoading();
	}
}

GameMode.prototype.fileLoading = function() {
	if (this.loadingType == "music") {
		this.loadingNum++;
		if (this.loadingNum >= BGM_LIST.length) {
			this.loadingNum = -1;
			this.loadingType = "sound";
			gameMode.fileLoading();
		} else {
			let ary = BGM_LIST[this.loadingNum].split(",");
			BGM[ary[0]] = new Audio("music/" + ary[1] + ".mp3");
			BGM[ary[0]].loop = true;
			BGM[ary[0]].load();
			BGM[ary[0]].addEventListener("canplaythrough",
				function() {
					gameMode.fileLoading();
				},
			false);
			BGM[ary[0]].addEventListener("error",
				function() {
					BGM[ary[0]] = null;
					gameMode.fileLoading();
				},
			false);
		}
	} else if (this.loadingType == "sound") {
		this.loadingNum++;
		if (this.loadingNum >= SE_LIST.length) {
			this.loadingType = "end";
			gameMode.fileLoading();
		} else {
			let ary = SE_LIST[this.loadingNum].split(",");
			SE[ary[0]] = new Audio("sound/" + ary[1] + ".mp3");
			SE[ary[0]].load();
			SE[ary[0]].addEventListener("canplaythrough",
				function() {
					gameMode.fileLoading();
				},
			false);
			SE[ary[0]].addEventListener("error",
				function() {
					SE[ary[0]] = null;
					gameMode.fileLoading();
				},
			false);
		}
	} else if (this.loadingType == "end") {
		this.loadingType = "wait"; // L[͑҂
	}
}

// ^Cgʂ̍XV
GameMode.prototype.titleUpdate = function() {
	this.titleSet();
	this.titleMenuSet();
	this.fieldView.update();
}

// ^Cgj[̃Zbg
GameMode.prototype.titleMenuSet = function() {
	var arignY = 12;
	this.fieldView.viewData[arignY] = strReplace(this.fieldView.viewData[arignY], 17, 'rs`qs@f`ld');
	var tmp;
	if (MusicOn) { tmp = 'ltrhbFnm'; }
	else { tmp = 'ltrhbFnee'; }
	this.fieldView.viewData[arignY-3] = strReplace(this.fieldView.viewData[arignY-3], 17, tmp);
	if (SeOn) { tmp = 'rntmcFnm'; }
	else { tmp = 'rntmcFnee'; }
	this.fieldView.viewData[arignY-5] = strReplace(this.fieldView.viewData[arignY-5], 17, tmp);
	if (MapOn) { tmp = 'ā^]ځF}bv\'; }
	else { tmp = 'ā^]ځFl̂'; }
	this.fieldView.viewData[arignY-7] = strReplace(this.fieldView.viewData[arignY-7], 17, tmp);

	var sel;
	if (this.selected == 0) { sel = arignY; }
	else if (this.selected == 1) { sel = arignY-3; }
	else if (this.selected == 2) { sel = arignY-5; }
	else if (this.selected == 3) { sel = arignY-7; }

	this.fieldView.viewData[sel] = strReplace(this.fieldView.viewData[sel], 15, '');
}

// ^CgS̃Zbg
GameMode.prototype.titleSet = function() {
	this.fieldView.viewClear();

	var title = new Array(
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@',
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@'
);
	var arignX = 2;
	this.fieldView.viewData[35] = strReplace(this.fieldView.viewData[35], arignX, title[0]);
	this.fieldView.viewData[34] = strReplace(this.fieldView.viewData[34], arignX, title[1]);
	this.fieldView.viewData[33] = strReplace(this.fieldView.viewData[33], arignX, title[2]);
	this.fieldView.viewData[32] = strReplace(this.fieldView.viewData[32], arignX, title[3]);
	this.fieldView.viewData[31] = strReplace(this.fieldView.viewData[31], arignX, title[4]);
	this.fieldView.viewData[30] = strReplace(this.fieldView.viewData[30], arignX, title[5]);
	this.fieldView.viewData[29] = strReplace(this.fieldView.viewData[29], arignX, title[6]);
	this.fieldView.viewData[28] = strReplace(this.fieldView.viewData[28], arignX, title[7]);
	this.fieldView.viewData[27] = strReplace(this.fieldView.viewData[27], arignX, title[8]);
	this.fieldView.viewData[26] = strReplace(this.fieldView.viewData[26], arignX, title[9]);
	this.fieldView.viewData[25] = strReplace(this.fieldView.viewData[25], arignX, title[10]);
	this.fieldView.viewData[24] = strReplace(this.fieldView.viewData[24], arignX, title[11]);

	this.fieldView.viewData[22] = strReplace(this.fieldView.viewData[22], 16, 's@̎@t');

}

// L[ꂽƂ
GameMode.prototype.onKeyPress = function(key) {
	if (this.loadingType == null || this.loadingType == undefined) { return; }
	if (this.loadingType == "wait") {
		this.loadingType = "";
		if (MusicOn) { musicStart("TITLE"); }
		this.titleUpdate();
		return;
	} else if (this.loadingType == "") {
		var change = 0;
		if (key == '8' || key == 'u' || key == 'U') {
			this.selected--;
			if (this.selected < 0) { this.selected = 3; }
			this.titleUpdate();
		} else if (key == '4' || key == 'h' || key == 'H') {
			change = 1;
		} else if (key == '6' || key == 'k' || key == 'K') {
			change = 1;
		} else if (key == '2' || key == 'n' || key == 'N') {
			this.selected++;
			if (this.selected > 3) { this.selected = 0; }
			this.titleUpdate();
		} else if (key == '5' || key == 'j' || key == 'J' || key == 'z' || key == 'Z') {
			if (this.selected == 0) {
				save(this.pcModel, this.partyModel);
				this.townMode.init();
			} else { change = 1; }
		} else if (key == 'r' || key == 'R') {
			this.mode = 'formatSet';
			this.subMenu(0);
			return;
		} else if ((key == 'p' || key == 'P') && View) {
			var pass = prompt("foOpR}hH", "");
			if (pass != null && pass != '') {
				if(Ie){
					var res = escape(pass);
					var pos = res.indexOf("%00");
					if(pos != -1){ res = res.substr(0,pos); }
					pass = unescape(res);
				}
				this.passCheck(pass);
			}
		}
	} else { return; }

	if (change) {
		if (this.selected == 1) {
			if (MusicOn) {
				MusicOn = 0;
				musicStop();
			}
			else {
				MusicOn = 1;
				musicStart("TITLE");
			}
		} else if (this.selected == 2) {
			if (SeOn) { SeOn = 0; }
			else { SeOn = 1; }
		} else if (this.selected == 3) {
			if (MapOn) { MapOn = 0; }
			else { MapOn = 1; }
		}
		this.titleUpdate();
	}
}

// Tuj[
GameMode.prototype.subMenu = function(num) {
	if (this.mode == 'formatSet') {
		this.textView.alert(27, 14, 1, 'f[^܂H');
		var choice = new Array('͂', '');
		this.selectionMode.start(this, choice, 22, 'center', num);
	}
	this.fieldView.update();
}

// 
GameMode.prototype.enter = function(num) {
	if (this.mode == 'formatSet') {
		if (num == 0) {
			allDataClear();
			this.init(true);
		} else if (num == 1) {
			this.mode = 'title';
			this.titleUpdate();
		}
	}
}

// E
GameMode.prototype.rightEnter = function(num) {
	this.subMenu(num);
}

// 
GameMode.prototype.leftEnter = function(num) {
	this.subMenu(num);
}

// LZ
GameMode.prototype.cancel = function(num) {
	if (this.mode == 'formatSet') {
		this.mode = 'title';
		this.titleUpdate();
	}
}

// foOpR}h
GameMode.prototype.passCheck = function(pass) {
	var i, j, k, pc = this.pcModel;

// full,item,map,age,gold,exp,abi,spell,level,recover

	if (pass == 'item' || pass == 'full') {
		for (j = 0; j < ItemStock.length; j++) {
			ItemStock[j] = 31;
		}
	}
	if (pass == 'map' || pass == 'full') {
		for (k = 0; k < FLOOR_MAX; k++) {
			for (i = 0; i < MAP_SIZE_X; i++) {
				for (j = 0; j < MAP_SIZE_Y; j++) {
					MapCheck[k][i + j * MAP_SIZE_X] = 1;
				}
			}
		}
	}
	for (i = 1; i < pc.length; i++) {
		if (pc[i].name == '') { break; }
		if (pass == 'age' || pass == 'full') {
			pc[i].ageWeek = 100;
		}
		if (pass == 'gold' || pass == 'full') {
			pc[i].gold = 9999999999;
		}
		if (pass == 'exp' || pass == 'full') {
			pc[i].exp = 9999999999;
		}
		if (pass == 'abi' || pass == 'full') {
			for (j = 0; j < 6; j++) {
				pc[i].abi[j] = ABILITY[pc[i].race][j] + 10;
			}
		}
		if (pass == 'spell' || pass == 'full') {
			for (j = 0; j < 7; j++) {
				pc[i].mSpell[j][0] = 1;
				pc[i].mSpell[j][1] = 1;
				pc[i].mSpell[j][2] = 1;
				pc[i].pSpell[j][0] = 1;
				pc[i].pSpell[j][1] = 1;
				pc[i].pSpell[j][2] = 1;
				if (pc[i].mpMMax[j] < 4) { pc[i].mpMMax[j] = 3; }
				if (pc[i].mpPMax[j] < 4) { pc[i].mpPMax[j] = 3; }
			}
		}
		if (pass == 'level' || pass == 'full') {
			pc[i].level = 100;
			pc[i].hpMax = pc[i].levelUpHp();
			pc[i].levelUpSpell();
		}
		if (pass == 'recover' || pass == 'spell' || pass == 'level' || pass == 'full') {
			pc[i].hp = pc[i].hpMax;
			for (j = 0; j < 7; j++) {
				pc[i].mpM[j] = pc[i].mpMMax[j];
				pc[i].mpP[j] = pc[i].mpPMax[j];
			}
			pc[i].state = 0;
		}
	}
}

// eXgL̃Zbg
GameMode.prototype.formatSet = function() {
	var pc = this.pcModel;
	pc[1].name = 'mP', pc[1].race = 0;
	pc[1].exp = 1724, pc[1].hpMax = 24;
	pc[1].alignment = 1, pc[1].pcClass = 0;
	pc[1].abi[0] = 13, pc[1].abi[1] = 8, pc[1].abi[2] = 8;
	pc[1].abi[3] = 11, pc[1].abi[4] = 8, pc[1].abi[5] = 8;
	pc[1].item[0] = 1, pc[1].itemS[0] = 1;
	pc[1].item[1] = 9, pc[1].itemS[1] = 1;
	pc[1].item[2] = 13, pc[1].itemS[2] = 1;;
	pc[1].item[3] = 14, pc[1].itemS[3] = 1;
	pc[2].name = 'mQ', pc[2].race = 2;
	pc[2].exp = 1724, pc[2].hpMax = 24;
	pc[2].alignment = 0, pc[2].pcClass = 0;
	pc[2].abi[0] = 14, pc[2].abi[1] = 7, pc[2].abi[2] = 10;
	pc[2].abi[3] = 14, pc[2].abi[4] = 5, pc[2].abi[5] = 6;
	pc[2].item[0] = 1, pc[2].itemS[0] = 1;
	pc[2].item[1] = 9, pc[2].itemS[1] = 1;
	pc[2].item[2] = 13, pc[2].itemS[2] = 1;;
	pc[2].item[3] = 14, pc[2].itemS[3] = 1;
	pc[3].name = 'm', pc[3].race = 3;
	pc[3].exp = 1810, pc[3].hpMax = 15;
	pc[3].alignment = 0, pc[3].pcClass = 2;
	pc[3].abi[0] = 10, pc[3].abi[1] = 7, pc[3].abi[2] = 13;
	pc[3].abi[3] = 8, pc[3].abi[4] = 12, pc[3].abi[5] = 7;
	pc[3].pSpell[0] = new Array(1,1,1), pc[3].pSpell[1] = new Array(1,1,1);
	pc[3].item[0] = 3, pc[3].itemS[0] = 1;
	pc[3].item[1] = 9, pc[3].itemS[1] = 1;
	pc[3].item[2] = 13, pc[3].itemS[2] = 1;
	pc[4].name = '', pc[4].race = 4;
	pc[4].exp = 1551, pc[4].hpMax = 12;
	pc[4].alignment = 1, pc[4].pcClass = 3;
	pc[4].abi[0] = 5, pc[4].abi[1] = 7, pc[4].abi[2] = 7;
	pc[4].abi[3] = 6, pc[4].abi[4] = 18, pc[4].abi[5] = 17;
	pc[4].item[0] = 2, pc[4].itemS[0] = 1;
	pc[4].item[1] = 8, pc[4].itemS[1] = 1;
	pc[4].item[2] = 12, pc[4].itemS[2] = 1;
	pc[5].name = 'i', pc[5].race = 1;
	pc[5].exp = 2105, pc[5].hpMax = 12;
	pc[5].alignment = 0, pc[5].pcClass = 4;
	pc[5].abi[0] = 7, pc[5].abi[1] = 12, pc[5].abi[2] = 12;
	pc[5].abi[3] = 6, pc[5].abi[4] = 9, pc[5].abi[5] = 10;
	pc[5].mSpell[0] = new Array(1,1,1);
	pc[5].item[0] = 3, pc[5].itemS[0] = 1;
	pc[5].item[1] = 9, pc[5].itemS[1] = 1;
	pc[6].name = '@g', pc[6].race = 0;
	pc[6].exp = 1896, pc[6].hpMax = 9;
	pc[6].alignment = 1, pc[6].pcClass = 1;
	pc[6].abi[0] = 8, pc[6].abi[1] = 14, pc[6].abi[2] = 8;
	pc[6].abi[3] = 8, pc[6].abi[4] = 10, pc[6].abi[5] = 8;
	pc[6].mSpell[0] = new Array(1,1,1), pc[6].mSpell[1] = new Array(1,1,1);
	pc[6].item[0] = 5, pc[6].itemS[0] = 1;
	pc[6].item[1] = 7, pc[6].itemS[1] = 1;
	var i, j;
	for (i = 1; i <= 6; i++) {
		pc[i].level = 3;
		pc[i].gold = dice(1, 100) + 50;
		pc[i].ageWeek = dice(1, 300) + 300;
		pc[i].levelUpSpell();
		for (j = 0; j < 7; j++) {
			pc[i].mpM[j] = pc[i].mpMMax[j];
			pc[i].mpP[j] = pc[i].mpPMax[j];
		}
		pc[i].hp = pc[i].hpMax;
	}

}

